#!/usr/bin/python
#Data description and generators bundled together in this file for publication.
#created on Thu Sep 10 16:26:47 2009
#by user: alod
#in path: /nfs/home1/alod/experiments/generators/1.04
#on machine: None
#generated with DFKI Synthetic Data Generators Pack (WGKS/WMCG) V1.03, 2009
#authors Aleksander Lodwich (aleksander.lodwich@dfki.de), Janick Frasch (janick.frasch@gmail.com), Thomas Breuel (tmb@iupr.com)
#get from http://paren.iupr.com
__name__ = 'deactivate pending self tests'

import os, sys
from numpy.random import *
import time
from scipy.linalg import *
from time import *
from pylab import *
from numpy import *
from scipy import *
import numpy
import scipy
from scipy.special import *
import csv
#==================================================================================================
#Normal Densities Utility Module For Dataset Generators
#Authors: Aleksander Lodwich, Janick Frasch and Thomas M. Breuel
#Remark: from the PaREn Project. 
#Refer to "Practical Bayes-True Data Generators For Evaluation of 
#          Machine Learning, Pattern Recognition and Data Mining Methods"
#
#This code is under MIT licence.
#Copyright (c) 2009, DFKI
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of 
#this software and associated documentation files (the "Software"), to deal in 
#the Software without restriction, including without limitation the rights to use, 
#copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
#Software, and to permit persons to whom the Software is furnished to do so, 
#subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
#FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
#COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
#IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
#CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#==================================================================================================


#==================================================================================================
#INCLUDES
#==================================================================================================


def white_gaussian( samples_count, dims ):
    result = zeros( (samples_count, dims) )
    for d in xrange( dims ):
        result[:,d] = normal(0.0, 1.0, size=(samples_count,))
    return result;
#end def white_gaussian____________________________________________________________________________


def normal_distribution( Count, Dimensions, mu, epsilon ):
    mu                  = atleast_2d( mu )
    EigenDescription    = eig( epsilon );                                      #Calculate destortion directions
    Transformation      = EigenDescription[1]  * sqrt(EigenDescription[0]).T;  #make transformation from white gauss to target gauss
    Temp                = white_gaussian( Count, Dimensions );                 #create white normal distribution
    NormalDistribution  = dot( Transformation, Temp.T ) + mu.T;                #apply transformation
    return NormalDistribution.T;                                               #return vector population
#end def normal_distribution_______________________________________________________________________


def normal_likelihood( vectors, center, epsilon_matrix ):
    """Helper function. Computes the likelihood of the density specified through >>inverse_epsilon<< and
    >>sqrt_determinant<< and >>center<< at position >>vector<<. This function
    returns a lieklihood for every vector.
    
    supply >>inverse_epsilon<< and >>sqrt_determinant<< from a central place. This speeds
    up the performance:
    inverse_epsilon  = linalg.inv( Epsilon )
    sqrt_determinant = sqrt( abs( linalg.det( Epsilon ) ) )
    
    Keyword arguments:
    vector -- 2d-numpy-array which can contain a series of vectors (in rows)
    center -- 2d-numpy-array. vector containing the center position of the gaussian
    inverse_epsilon -- 2d--numpy-array. matrix with the inverse of the cov matrix
    sqrt_determinant -- float. square root of absolute determinant of the cov matrix
    """

    center = atleast_2d( center );
    sqrt_determinant = sqrt( linalg.det( epsilon_matrix ) );
    inverse_epsilon = linalg.inv( epsilon_matrix );

    j = vectors - center;    
    d = len( center );
    b = transpose(exp( -0.5 * sum(j.T * dot(inverse_epsilon, j.T), 0) ) / ((2 * pi)**(d / 2.0) * sqrt_determinant));
    return b;
#end def normal_likelihood_________________________________________________________________________


def normal_likelihood_optimized( vectors, center, inv_sigma, sqrt_det_sigma ):
    """Helper function. Computes the likelihood of the density specified through >>inverse_epsilon<< and
    >>sqrt_determinant<< and >>center<< at position >>vector<<. This function
    returns a lieklihood for every vector.
    
    supply >>inverse_epsilon<< and >>sqrt_determinant<< from a central place. This speeds
    up the performance:
    inverse_epsilon  = linalg.inv( Epsilon )
    sqrt_determinant = sqrt( abs( linalg.det( Epsilon ) ) )
    
    Keyword arguments:
    vector -- 2d-numpy-array which can contain a series of vectors (in rows)
    center -- 2d-numpy-array. vector containing the center position of the gaussian
    inverse_epsilon -- 2d--numpy-array. matrix with the inverse of the cov matrix
    sqrt_determinant -- float. square root of absolute determinant of the cov matrix
    """

    center = atleast_2d( center );
    sqrt_determinant = sqrt_det_sigma;
    inverse_epsilon = inv_sigma;

    j = vectors - center;  
    d = len( center );
    b = transpose(exp( -0.5 * sum(j.T * dot(inverse_epsilon, j.T), 0) ) / ((2 * pi)**(d / 2.0) * sqrt_determinant));
    return b;
#end def normal_likelihood_optimized_______________________________________________________________


#==================================================================================================
#END OF FILE
#==================================================================================================

Table_y_shift = {2: 0., \
        3: 0.78545073168099999, \
        4: 1.18614011249, \
        5: 1.43909624827, \
        6: 1.6308353824199999, \
        7: 1.77032540369, \
        8: 1.8869956481300001, \
        9: 2.0057598688099998, \
        10: 2.0834668720799998, \
        11: 2.15502439144, \
        12: 2.2265819107899998, \
        13: 2.2879206293699998, \
        14: 2.3492593479599999, \
        15: 2.3981006331599999, \
        16: 2.4469419183599999, \
        17: 2.4835660326100002, \
        18: 2.5201901468600001, \
        19: 2.5589019888700002, \
        20: 2.5976138308699999, \
        21: 2.62650311209, \
        22: 2.6553923933000001, \
        23: 2.6842816745200002, \
        24: 2.7131709557299999, \
        25: 2.74206023695, \
        26: 2.7647745635800001, \
        27: 2.7874888902000001, \
        28: 2.8102032168300002, \
        29: 2.8329175434499998, \
        30: 2.8556318700799999, \
        31: 2.8745581194300001, \
        32: 2.8934843687799998, \
        33: 2.91241061813, \
        34: 2.9313368674800002, \
        35: 2.95026311683, \
        36: 2.9653162365100001, \
        37: 2.9803693562000002, \
        38: 2.9954224758799999, \
        39: 3.01047559557, \
        40: 3.0255287152500001, \
        41: 3.04045652276, \
        42: 3.0553843302699999, \
        43: 3.0703121377899998, \
        44: 3.0852399453000001, \
        45: 3.10016775281, \
        46: 3.1115333336900002, \
        47: 3.1228989145699999, \
        48: 3.1342644954400001, \
        49: 3.1456300763199998, \
        50: 3.1569956572, \
        51: 3.1644660956199999, \
        52: 3.1719365340399999, \
        53: 3.1794069724599998, \
        54: 3.1868774108700002, \
        55: 3.1943478492900002, \
        56: 3.2018182877100001, \
        57: 3.20928872613, \
        58: 3.21675916455, \
        59: 3.2242296029699999, \
        60: 3.2317000413799999, \
        61: 3.2391704797999998, \
        62: 3.2466409182199998, \
        63: 3.2541113566400002, \
        64: 3.2615817950600001, \
        65: 3.2690522334800001, \
        66: 3.27652267189, \
        67: 3.28399311031, \
        68: 3.2914635487299999, \
        69: 3.2989339871499999, \
        70: 3.3064044255699998, \
        71: 3.3138748639900002, \
        72: 3.3213453024000001, \
        73: 3.3288157408200001, \
        74: 3.33628617924, \
        75: 3.34375661766, \
        76: 3.3512270560799999, \
        77: 3.3586974944999999, \
        78: 3.3661679329199998, \
        79: 3.3736383713300002, \
        80: 3.3811088097500002, \
        81: 3.3885792481700001, \
        82: 3.3960496865900001, \
        83: 3.40352012501, \
        84: 3.41099056343, \
        85: 3.4184610018399999, \
        86: 3.4259314402599998, \
        87: 3.4334018786799998, \
        88: 3.4408723171000002, \
        89: 3.4483427555200001, \
        90: 3.4558131939400001, \
        91: 3.46328363235, \
        92: 3.47075407077, \
        93: 3.4782245091899999, \
        94: 3.4856949476099999, \
        95: 3.4931653860299998, \
        96: 3.5006358244500002, \
        97: 3.5081062628600002, \
        98: 3.5155767012800001, \
        99: 3.5230471397000001, \
        100: 3.53051757812};

#==================================================================================================
#Optimizer Methods For Dataset Generators
#Authors: Aleksander Lodwich, Janick Frasch and Thomas M. Breuel
#Remark: from the PaREn Project. 
#Refer to "Practical Bayes-True Data Generators For Evaluation of 
#          Machine Learning, Pattern Recognition and Data Mining Methods"
#
#This code is under MIT licence.
#Copyright (c) 2009, DFKI
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of 
#this software and associated documentation files (the "Software"), to deal in 
#the Software without restriction, including without limitation the rights to use, 
#copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
#Software, and to permit persons to whom the Software is furnished to do so, 
#subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
#FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
#COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
#IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
#CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#==================================================================================================


#==================================================================================================
#INCLUDES
#==================================================================================================


#==================================================================================================
#FUNCTIONS
#==================================================================================================

def descent( eval_function, initial_values, tau=0.15,
            max_runs=1000, epsilon=0.001, scale_up = 1.5, base = 0.7,
            initial_rate = 1.0, healing_rate = 0.9, step_limit=1.0, heals=10 ):
    """descent implements a gradient descent with a few heuristics for learning rate adaptation.
    This function returns a vector as optimal result.

    Keyword Arguments:
    eval_function:          function handle callable by the form   f(numpy.array(v))
    initial_values:         1d array. Starting position in optimization space.
    tau:                    float>0. This value specifies the numerical delta for derivative computation
    max_runs:               int>>1. Maximum number of optimization epochs.
    epsilon:                float>0. Constant for early termination.
    scale_up:               float>1.0. Maximum scale up for the learning rate for each epoch
    base:                   float[-1,1]. Cosine of weight change angle where learning rate is not adapted
    initial_rate:           float>0. Initial learning rate
    healing_rate:           float[0,1]. If obscure numerical problems occur, then make the optimization parameters less aggressive by this factor
    step_limit:             float>0. Avoid fly-away effects. Maximum step vector norm.
    heals:                  int>=0. Number of healing attempts before it gives up.
    """
    good = 0;
    position = copy( initial_values );
    dims = len( position );
    deltas = eye( dims );
    adaptation = 1.0;
    print "INITIALIZING NUMERICAL DESCENT --- SCALE_UP:", scale_up, "BASE:",base, "POS:", position
    while not good and heals>0:
        lr = initial_rate
        delta_old = zeros( position.shape );
        old_score = eval_function( position );
        good = 1; #assume it's good
        for i in xrange( max_runs ):
            #optimizer section
            old_position = copy( position );
            #print "DEBUG position", position
            #print "DEBUG deltas", deltas
            gradient = zeros( dims );
            for dim in xrange( dims ):
                #print "DEBUG position+", position + deltas[dim]*tau
                #print "DEBUG position-", position - deltas[dim]*tau
                #print position, deltas[dim]*tau
                gradient[dim] = (eval_function( position + deltas[dim]*tau ) - eval_function( position - deltas[dim]*tau ))/(2*tau)
            #print "\rDEBUG LR:",lr, "GRAD:", gradient, "+d:", eval_function( position + deltas[dim]*tau ), "-d:", eval_function( position - deltas[dim]*tau ),
            position -= lr * gradient;
            delta_new = position-old_position;
            score = eval_function( position );
            try:
                #section for LR adaptation
                DIR = float(dot( delta_new/(linalg.norm(delta_new)+1e-308), delta_old/(linalg.norm(delta_old)+1e-308) ))
                #what does the next line do: if step length changes somehow unexpected from what the lr suggest, then become cautious!
                #print "old:",linalg.norm(delta_old),"new:",linalg.norm(delta_new), "lr:",lr
                DIR *= min((linalg.norm(delta_old)*adaptation)/linalg.norm(delta_new), linalg.norm(delta_new)/(adaptation*linalg.norm(delta_old)) ); #the concept of direction doesn't work well in 1D


                delta_old = delta_new;
                if i > 0:
                    adaptation = float(exp( (DIR-base)/((1.0-base)*(1.0/(log(scale_up))))))
                else: adaptation=1.0


                print "\rEPOCH", i, "ERROR:", score, "LR:", lr, "G:", gradient, "POS:", position, "DIR:", DIR, "ADAPT:", adaptation,
                sys.stdout.flush()

                if linalg.norm( gradient ) < epsilon or lr < epsilon:
                    print "EARLY STOP DUE TO EPSILON"
                    return position;
            except Exception, e:
                print e
                #new numpy style healing
                good = 0;
                scale_up = (scale_up-1.0)*healing_rate+1.0;
                base = 1.0 - (1.0-base)*healing_rate;
                initial_rate *= healing_rate;
                heals -= 1;
                #tau *= healing_rate;
                position = copy( initial_values );
                print "\nSCALE_UP:", scale_up, "BASE:",base, "initial_rate:", initial_rate, "POS:", position
                print "HEALING"
                break;

            lr *= adaptation;
            old_score = score;
    print "LATE STOP DUE TO MAX_RUNS"
    return position;
#end def descent___________________________________________________________________________________


def descent_with_analytical_gradient( eval_function, eval_function_derivation, initial_values, 
                                        max_runs=1000, epsilon=0.0001, scale_up = 1.5, base = 0.7,
                                        initial_rate = 1.0, healing_rate = 0.9, step_limit=1.0, heals=10 ):
    """descent implements a gradient descent with a few heuristics for learning rate adaptation.
    This function returns a vector as optimal result.

    Keyword Arguments:
    eval_function:          function handle callable by the form   f(numpy.array(v))
    eval_function_derivation: function handle callable by the form   f(numpy.array(v))
    initial_values:         1d array. Starting position in optimization space.
    tau:                    float>0. This value specifies the numerical delta for derivative computation
    max_runs:               int>>1. Maximum number of optimization epochs.
    epsilon:                float>0. Constant for early termination.
    scale_up:               float>1.0. Maximum scale up for the learning rate for each epoch
    base:                   float[-1,1]. Cosine of weight change angle where learning rate is not adapted
    initial_rate:           float>0. Initial learning rate
    healing_rate:           float[0,1]. If obscure numerical problems occur, then make the optimization parameters less aggressive by this factor
    step_limit:             float>0. Avoid fly-away effects. Maximum step vector norm.
    heals:                  int>=0. Number of healing attempts before it gives up.
    """
    good = 0;
    position = copy( initial_values );
    dims = len( position );
    deltas = eye( dims );
    adaptation=1.0;
    print "INITIALIZING --- SCALE_UP:", scale_up, "BASE:",base, "POS:", position
    while not good and heals>0:
        lr = initial_rate
        delta_old = zeros( position.shape );
        old_score = eval_function( position );
        good = 1;
        for i in xrange( max_runs ):
            #optimizer section
            old_position = copy( position );
            gradient = eval_function_derivation( position );
            position -= minimum( step_limit, maximum(-step_limit, lr * gradient )); #empiric hack
            delta_new = position-old_position;
            score = eval_function( position );

            #section for LR adaptation
            try:
                DIR = float(dot( delta_new/(linalg.norm(delta_new)+1e-308), delta_old/(linalg.norm(delta_old)+1e-308) ))
                #what does the next line do: if step length changes somehow unexpected from what the lr suggest, then become cautious!
                DIR *= min((linalg.norm(delta_old)*adaptation)/linalg.norm(delta_new), linalg.norm(delta_new)/(adaptation*linalg.norm(delta_old)) ); #the concept of direction doesn't work well in 1D
                delta_old = delta_new;
                if i > 0:
                    adaptation = exp( (DIR-base)/((1.0-base)*(1.0/(log(scale_up)))))
                else: adaptation=1.0


                if linalg.norm( gradient ) < epsilon or lr < epsilon:
                    print "EARLY STOP DUE TO EPSILON"
                    return position;
                else: 
                    print "\rEPOCH", i, "ERROR:", score, "LR:", lr, "G:", gradient, "POS:", position, "DIR:", DIR, "ADAPT:", adaptation,
                    sys.stdout.flush()
            except:
                #new numpy style healing
                good = 0;
                scale_up = (scale_up-1.0)*healing_rate+1.0;
                base = 1.0 - (1.0-base)*healing_rate;
                initial_rate *= healing_rate;
                heals -=1;
                position = copy( initial_values );
                print "SCALE_UP:", scale_up, "BASE:",base
                print "HEALING"
                break;


            #old style numpy self healing
            if isnan(score) or isnan(lr) or isnan(gradient) or isnan(float(position)) or isnan(DIR) or isnan(adaptation):
                good = 0;
                scale_up = (scale_up-1.0)*healing_rate+1.0;
                base = 1.0 - (1.0-base)*healing_rate;
                heals -=1;
                position = copy( initial_values );
                print "SCALE_UP:", scale_up, "BASE:",base
                print "HEALING"
                break;

            lr *= adaptation;
            old_score = score;
    print "LATE STOP DUE TO MAX_RUNS"
    return position;
#end def descent_with_analytical_gradient__________________________________________________________


def setup_simplex( n, distance ):	
    """Helper function. Creates a numpy array with coordinates of a n-simplex where any edge is >>distance<< long. 
    The return value is a 2d-numpy-array.

    Keyword arguments:
    n -- int. number of densities
    distance -- float. distance apart for densities
    """
    
    if n <= 1:
        return array([[0]])
    
    result = zeros((n, n-1))
    sub_simplex = setup_simplex(n-1, distance)
    base_foot = sub_simplex.sum(0) / (n - 1)
    r = linalg.norm(base_foot)
    y = sqrt(distance**2 - r**2)
    result[0:n-1,0:n-2] = sub_simplex
    result[n-1,0:n-2] = base_foot
    result[n-1,n-2] = y
    return result
#end def setup_simplex_____________________________________________________________________________


def amoeba( eval_function, dims, initial_values=None, gamma=2.0, beta=0.5, sigma=0.5, max_runs=1000, e1=0.000001, e2=0.000001, e3=0.000001, abort_under_cost=None ):
    """amoeba is a downhill simplex optimizer as described in Nelder and Mead, 1965.
    amoeba is well suited for continuous problems but it can get stuck in a local minimum, just like any other local method.

    Keyword arguments:
    eval_function -- function. fitnes function must take a vector and return a scalar value
    dims -- int. what is the number of dimensions to optimize in
    initial_values -- 2d numpy array or None. starting shape of the simplex. it must fit the size (dims+1)x(dims)
    gamma -- float. expansion coefficient (should of course be always > 1.0 )
    betta -- float. inner kontraction coefficient. (between 0.0 and 1.0)
    sigma -- float. total kontraction coefficient. (between 0.0 and 1.0)
    max_runs -- int. maximal number of optimization steps. (>0)
    e1 -- float. if average of function values changes less then e1, then stop
    e2 -- float. if the newly set vertex is closer to simplex than e2, then stop
    e3 -- float. if the positioning of the new vertex improved the best fitness score less then e3, then stop
    """

    def update_all_values( simplex, dims, eval_function ):
        """ helper function defined internally because this part is used twice """
        for i in range( dims+1 ):
            simplex[i,0] = eval_function( simplex[i,1:] );
        #END OF FUNCTION

    #BEGIN AMOEBA
    simplex = zeros( ( dims+1, dims+1 ) );
    if initial_values is not None:
        simplex[:,1:] = initial_values;
    else:
        simplex[:,1:] = setup_simplex( dims+1, 1.0 );

    update_all_values( simplex, dims, eval_function );

    correction2 = 1.0 / ( dims + 1 );
    correction1 = (dims+1.0) / dims
    for epoch in range( max_runs ):
        #print simplex
        ref = argmax( simplex[:,0] );    
        refvec = simplex[ref,1:].copy();
        center = mean( concatenate( ( simplex[0:ref,1:], simplex[ref+1:,1:]), 0 ), 0 )
        #print "center:", center
        #plot( simplex[:,1], simplex[:,2], 'x' );
        #plot( array([center[0]]), array([center[1]]), 'x' ); xlim( [ -3, 10]); ylim( [-3,10]); show();

        deltavec = center-refvec;
        regular_flip_vec = center + deltavec;
        regular_flip_fit = eval_function( regular_flip_vec );
        
        SortedValues = simplex[:,0].copy();
        SortedValues.sort();
        #print SortedValues
        MinFit = SortedValues[0];
        MaxFit = SortedValues[-1];
        LesFit = SortedValues[-2];
        MinFit = min( simplex[:,0] );
        MaxFit = max( simplex[:,0] );
        CurFit = mean( simplex[:,0] );

        #print "Min", MinFit, "Max", MaxFit, "Les", LesFit
        print "\rEPOCH",epoch,":",
        if regular_flip_fit < MinFit:
            #EXPANSION
            expanded_flip_vec = center + gamma * deltavec;
            expanded_flip_fit = eval_function( expanded_flip_vec );

            if expanded_flip_fit < regular_flip_fit:
                #ONLY FLIP
                print "ONLY FLIP 1",
                simplex[ref,1:] = expanded_flip_vec;
                simplex[ref,0] = expanded_flip_fit;
            else:
                #FLIP AND EXPAND
                print "FLIP AND EXPAND",
                simplex[ref,1:] = regular_flip_vec;
                simplex[ref,0] = regular_flip_fit;
        elif regular_flip_fit >= LesFit and regular_flip_fit < MaxFit:
            #OUTER KONTRACTION
            contracted_flip_vec = center + beta * deltavec;
            contracted_flip_fit = eval_function( contracted_flip_vec );            

            if contracted_flip_fit < regular_flip_fit:
                #FLIP AND CONTRACT
                print "FLIP AND CONTRACT",
                simplex[ref,1:] = contracted_flip_vec;
                simplex[ref,0] = contracted_flip_fit;
            else:
                #SCHRINK ALL SIDES
                print "SHRINK ALL SIDES 1",
                simplex[:,1:] = ( simplex[:,1:] - center ) * sigma + center;
                update_all_values( simplex, dims, eval_function );
        elif regular_flip_fit >= MaxFit:
            #INNER CONTRACTION
            contracted_vec = center - beta * deltavec;
            contracted_fit = eval_function( contracted_vec );            
            
            if contracted_fit < MaxFit: # and contracted_fit < regular_flip_fit:
                #CONTRACT BUT DO NOT FLIP
                print "CONTRACT BUT DO NOT FLIP",
                simplex[ref,1:] = contracted_vec;
                simplex[ref,0] = contracted_fit;
            else:
                #SCHRINK ALL SIDES
                print "SHRINK ALL SIDES 2",
                simplex[:,1:] = ( simplex[:,1:] - center ) * sigma + center;
                update_all_values( simplex, dims, eval_function );
        else:
            #JUST FLIP A BIT
            print "ONLY FLIP 2",
            simplex[ref,1:] = regular_flip_vec;
            simplex[ref,0] = regular_flip_fit;

        if mean( SortedValues ) < e1:
            print "STOP DUE TO AVERAGE FUNCTION CHANGE"
            return center;

        if linalg.norm( refvec - simplex[ref,1:] ) < e2:
            print "STOP DUE TO TOO SMALL SIMPLEX CHANGE"
            return center;

        if abs( MaxFit - simplex[ref,0] ) < e3:
            print "STOP DUE TO MARGINAL IMPROVEMENT"
            return center;

        if abort_under_cost is not None:
            if CurFit < abort_under_cost:
                print "STOP DUE TO QUITE OPTIMAL COST"
                return center

        sys.stdout.flush()
    return center;
#end def amoeba____________________________________________________________________________________


#==================================================================================================
#END OF FILE
#==================================================================================================

#==================================================================================================
#White Gaussians on Chain Generator WGKS
#Authors: Aleksander Lodwich, Janick Frasch and Thomas M. Breuel
#Remark: from the PaREn Project. 
#Refer to "Practical Bayes-True Data Generators For Evaluation of 
#          Machine Learning, Pattern Recognition and Data Mining Methods"
#
#This code is under MIT licence.
#Copyright (c) 2009, DFKI
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of 
#this software and associated documentation files (the "Software"), to deal in 
#the Software without restriction, including without limitation the rights to use, 
#copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
#Software, and to permit persons to whom the Software is furnished to do so, 
#subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
#FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
#COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
#IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
#CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#==================================================================================================
#
#==================================================================================================
#OVERVIEW OVER FUNCTIONAL DEPENDENCIES
#==================================================================================================
#
#                                white_gaussians_on_k_simplex()
#                                              |
#      +-------------------------+-------------+-----------+----------------------------------+
#      |                         |                         |                                  |
#edge_length_of_k_simplex_lut()  |       edge_length_of_k_simplex_numerical_descent()     k_white_gaussians()
#      |                         |                         |                                  |
#      +----------------+        |                         |                                  |
#      |                |        |                         |                                  |
# extrapolate_y_shift() | edge_length_of_k_simplex_amoeba()|                                 /|
#                       |        |            +------------+                                / |
#                       |        +-----------/------+      |                               /  |
#                       |        |          /        \     |                              /   |
#                       +---adapt_error_function()   FastWGKSErrorModel                  /   position_whites()
#                       |        |                         |                            /     |
#                       +--modulated_erro_function()       +----------setup_simplex()--+      +--------------+
#                                |                                                            |              |
#                              erfcinv()                                                white_gaussian()     |
#                                |                                                                  gauss_likelihood()
#                              ltqnorm()
#
#   TRY_LUT
#      |
#      +--------------------------------+
#      |                                |
#   reproduce_lookup_table()       secure_lut()
#
#
#    TEST_CASES
#      |
#    sort_rows()
#
#==================================================================================================


#==================================================================================================
#INCLUDES
#==================================================================================================


class FastWGKSErrorModel:
    """This class is a cookie class for the optimization, as the optimizers do
    not provide means of passing constants to the cost function.
    """

    def __init__( self, k, target_error, samples=50000 ):
        """This is the constructor that stores and pregenerates constants for the cost_function

        Keyword Arguments:
        k:              int>1. Number of densities
        target_error:   float[0,1]. Wished Bayes error rate.
        samples:        int>>1. Number of samples per density
        """
        vertices = setup_simplex( k, 1.0 );
        center = vertices.mean( 0 );  
        self.my_recovery_ratio = 1.0 / linalg.norm( center );
        self.my_dims = k - 1;
        self.my_S = (center - vertices[1:,:])/sqrt(((center - vertices[1:,:])**2).sum(1)) #this will create a coordinate system matrix
        self.my_S_inverse = linalg.inv( self.my_S )
        self.my_sigma = dot( self.my_S_inverse.T, self.my_S_inverse )
        self.my_samples = normal_distribution( samples, self.my_dims, zeros(self.my_dims), self.my_sigma )
        self.my_target_error = target_error;
    #END DEF __INIT__
        

    def bayes_error( self, l_dash ):
        """Computes the Bayes error by 1st. octant discounting"""
        samples = copy( self.my_samples ) + ones( self.my_dims ) * l_dash
        accuracy =  mean(( sign( samples ) > 0 ).all( 1 ));
        return 1.0 - accuracy;
    #END DEF bayes_error


    def convert_2_true_edge_length( self, l_dash ):
        return self.my_recovery_ratio * l_dash
    #END DEF convert_2_true_edge_length


    def cost_function( self, v ):
        return ( self.my_target_error - self.bayes_error( v ) )**2
    #END DEF cost_function    
#END DEF CLASS FastWGKSErrorModel__________________________________________________________________



def reproduce_lookup_table( optimizer="amoeba", samples_for_optimization=1e6, average_over=50, grow=1.15, repeat=34 ):
    """reproduce_lookup_table is the function that reproduces the look up table for the WGKS. Normally this 
    is not used.

    Keyword Arguments:
    optimizer:                  string ("amoeba","descent").
    samples_for_optimization:   int>>>1.
    average_over:               int>>1.
    grow:                       float>1.0. Growth base for test distribution
    repeat:                     int>>1. How many growth operations shall be performed.
    """
    dims = unique(int32(grow**arange(repeat)))[1:]; #never take 1 and do not repeat anything twice
    total = average_over*len(dims)
    factor = 1.0 / average_over;
    counter = 0
    t1 = time();
    table = {}
    #repeat estimations by optimizer for average_over times:
    for run in arange( average_over ):
        for dim in dims: #estimate for every support dimension: dimensions in between are not estimated.
            print "K=", dim, "RUN=",run
            if dim == 2:
                table[dim]=0.0;
            else:
                error_model = FastWGKSErrorModel( dim, 0.5, samples_for_optimization ) #samples_per_density*k );  #optimize for 50% error
                y = amoeba( error_model.cost_function, 1 )[0]
                table[dim] = table.get( dim, 0.0 ) + factor * error_model.convert_2_true_edge_length( y )
            P = counter*100.0/total
            if P==0:
                ETA = "???"
            else:
                ETA = 100*((time()-t1)/P)-(time()-t1)
            print "PROGRESS:%2.2f"%P+"% ETA:", ETA, "s"
            counter+=1
        
    #now it is neccessary to compact and interpolate the values into a look up table:
    max_dim = max(dims+1)
    result_dims   = arange( 2, max_dim )
    result_values = zeros( max_dim-2 )
    keys = table.keys()
    last_dim = keys.pop(0)
    for d in result_dims:
        if d==last_dim:
            result_values[d-2] == table[d]
        if d>last_dim and d<keys[0]:
                result_values[d-2] = ((d-last_dim)*(table[keys[0]]-table[last_dim])/(keys[0]-last_dim))+table[last_dim] #interpolate
        if len(keys)>0 and d==keys[0]:
                last_dim = keys.pop(0)
                result_values[d-2] = table[d]
        if len(keys)==0:
                result_values[d-2] = table[last_dim]
    result = {}
    print "result_dims:", result_dims
    print "result_values:", result_values
    for d in result_dims:
        result[d] = result_values[d-2]    
    return result;
#END DEF reproduce_lookup_table____________________________________________________________________


def secure_lut( table, filename="lut.py" ):
    """saves the lut to a file.

    Keywords Arguments:
    table:          dictionary. Keys are ints 2..100 and values are s_k floats.
    fileanme:       string. Path to lut.py
    """
    f = open( filename, "w" );
    f.write( "Table_y_shift = " +str(table).replace(",",",\n")+"\n" );
    f.close();
#END DEF secure_lut________________________________________________________________________________




#In this TRY we try to load lut.py. If it's not there, then lut needs to get regenerated.
try:
    #UNCOMMENT THE NEXT LINE IF YOU WANT TO USE FALLBACK SOLUTION
    #raise Exception
    for i in arange(2,100):
        if not Table_y_shift.has_key( i ):
            print "PROBLEM WITH lut.py: MISSING KEYS"
            raise Exception
        if i>2 and Table_y_shift[i] < Table_y_shift[i-1]:
            print "PROBLEM WITH lut.py: BAD VALUES!"
            print "i:", i-1, "val:", Table_y_shift[i-1]
            print "i:", i, "val:", Table_y_shift[i]
            raise Exception 
except: #if lut is not there then:
    print "Do you want to use default table [D] or do you want to regenerate the table[R]?",
    answer = sys.stdin.readline();
    if answer[0].upper() == "D":
        #FALLBACK SOLUTION FROM PAPER
        Table_y_shift = {2: 0., \
        3: 0.78545073168099999, \
        4: 1.18614011249, \
        5: 1.43909624827, \
        6: 1.6308353824199999, \
        7: 1.77032540369, \
        8: 1.8869956481300001, \
        9: 2.0057598688099998, \
        10: 2.0834668720799998, \
        11: 2.15502439144, \
        12: 2.2265819107899998, \
        13: 2.2879206293699998, \
        14: 2.3492593479599999, \
        15: 2.3981006331599999, \
        16: 2.4469419183599999, \
        17: 2.4835660326100002, \
        18: 2.5201901468600001, \
        19: 2.5589019888700002, \
        20: 2.5976138308699999, \
        21: 2.62650311209, \
        22: 2.6553923933000001, \
        23: 2.6842816745200002, \
        24: 2.7131709557299999, \
        25: 2.74206023695, \
        26: 2.7647745635800001, \
        27: 2.7874888902000001, \
        28: 2.8102032168300002, \
        29: 2.8329175434499998, \
        30: 2.8556318700799999, \
        31: 2.8745581194300001, \
        32: 2.8934843687799998, \
        33: 2.91241061813, \
        34: 2.9313368674800002, \
        35: 2.95026311683, \
        36: 2.9653162365100001, \
        37: 2.9803693562000002, \
        38: 2.9954224758799999, \
        39: 3.01047559557, \
        40: 3.0255287152500001, \
        41: 3.04045652276, \
        42: 3.0553843302699999, \
        43: 3.0703121377899998, \
        44: 3.0852399453000001, \
        45: 3.10016775281, \
        46: 3.1115333336900002, \
        47: 3.1228989145699999, \
        48: 3.1342644954400001, \
        49: 3.1456300763199998, \
        50: 3.1569956572, \
        51: 3.1644660956199999, \
        52: 3.1719365340399999, \
        53: 3.1794069724599998, \
        54: 3.1868774108700002, \
        55: 3.1943478492900002, \
        56: 3.2018182877100001, \
        57: 3.20928872613, \
        58: 3.21675916455, \
        59: 3.2242296029699999, \
        60: 3.2317000413799999, \
        61: 3.2391704797999998, \
        62: 3.2466409182199998, \
        63: 3.2541113566400002, \
        64: 3.2615817950600001, \
        65: 3.2690522334800001, \
        66: 3.27652267189, \
        67: 3.28399311031, \
        68: 3.2914635487299999, \
        69: 3.2989339871499999, \
        70: 3.3064044255699998, \
        71: 3.3138748639900002, \
        72: 3.3213453024000001, \
        73: 3.3288157408200001, \
        74: 3.33628617924, \
        75: 3.34375661766, \
        76: 3.3512270560799999, \
        77: 3.3586974944999999, \
        78: 3.3661679329199998, \
        79: 3.3736383713300002, \
        80: 3.3811088097500002, \
        81: 3.3885792481700001, \
        82: 3.3960496865900001, \
        83: 3.40352012501, \
        84: 3.41099056343, \
        85: 3.4184610018399999, \
        86: 3.4259314402599998, \
        87: 3.4334018786799998, \
        88: 3.4408723171000002, \
        89: 3.4483427555200001, \
        90: 3.4558131939400001, \
        91: 3.46328363235, \
        92: 3.47075407077, \
        93: 3.4782245091899999, \
        94: 3.4856949476099999, \
        95: 3.4931653860299998, \
        96: 3.5006358244500002, \
        97: 3.5081062628600002, \
        98: 3.5155767012800001, \
        99: 3.5230471397000001, \
        100: 3.53051757812};
    if answer[0].upper() == "R":
        table = reproduce_lookup_table();
        secure_lut( table );
#END OF TRY LOAD lut.py____________________________________________________________________________
  

def extrapolate_y_shift(k): #only makes sense for k > 100
    """extrapolate_y_shift is a helper function: 
    extrapolation for k > 100 according to least squares on  values of 50,75,100,200,500
    """

    #precalculated data
    data = array([[75.,3.42],[100.,3.531],[150.,3.75],[200.,3.86],[500.,4.28]]);
    
    #data is supposed to be logarithmic in k
    for i  in xrange(len(data)):
        data[i][1] = exp(data[i][1]);
    #end for
    
    #least squares for finding parameters of linear function
    k_mean = 1./len(data) * sum(data,0)[0];
    y_mean = 1./len(data) * sum(data,0)[1];
    
    a = dot((data.T[0] - k_mean),(data.T[1] - y_mean))/norm(data.T[0] - k_mean)**2.;
    t = y_mean - a * k_mean;
    
    #print a
    #print t
    
    return log(a*k + t);
#END DEF extrapolate_y_shift_______________________________________________________________________


def adapt_error_function(k, y_shift):
    """adapt_error_function is a helper function for finding steepness parameter of Inverse Error Function"""
    
    #analytical calculation of steepness (linear transformation of ErfInv
    if not (k == 2):
        steepness = -modulated_error_function((k-1.)/k, 0, -1., 1.) / (0. - y_shift);
    else:
        #der Grund liegt in Normierung der Errorfunction: Die allgemeine Errorfunction, 
        #so wie sie mit der Aproximation im Code berechnet wird, ist anders normiert als die 
        #Gaussche Fehlerfunktion. Der Umrechnungsfaktor ist (1/sqrt(2*pi))/(2/sqrt(pi)) was 
        #ungefaehr  0.353553 ist. 
        steepness = -0.347 #better practical results
        #steepness = -0.353553 #theoretical value
    return steepness;
#END DEF adapt_error_function______________________________________________________________________

def modulated_error_function(x_values, y_center=0., steepness=1., x_width=2.):
    """Helper function. Generates a modulated inverse errorfunction with more parameters.
    returns an array. 
    
    Keyword arguments:
    x_values --	list of the x coordinates of the inverse error function
    y_center -- float. vertical center of the Errorfunction, translation parallel to y axis (Standard = 0)
    steepness -- float. steepness of the inverse Errorfunction, relative scale in y direction (Standard = 1)
    x_width -- float. absolute width of the Errorfunction, scale in x direction (Standard = 2)
    """
    
    x = array(x_values);
    y = (-1./steepness) * erfcinv( (2./x_width) * x) + y_center;   
    Result = array(y).T;
    return Result
#END DEF modulated_error_function__________________________________________________________________


def setup_simplex( n, distance ):	
    """Helper function. Creates a numpy array with coordinates of a n-simplex where any edge is >>distance<< long. 
    The return value is a 2d-numpy-array.

    Keyword arguments:
    n -- int. number of densities
    distance -- float. distance apart for densities
    """
    
    if n <= 1:
        return array([[0]])
    
    result = zeros((n, n-1))
    sub_simplex = setup_simplex(n-1, distance)
    base_foot = sub_simplex.sum(0) / (n - 1)
    r = linalg.norm(base_foot)
    y = sqrt(distance**2 - r**2)
    result[0:n-1,0:n-2] = sub_simplex
    result[n-1,0:n-2] = base_foot
    result[n-1,n-2] = y
    return result
#END DEF setup_simplex_____________________________________________________________________________


def sort_rows( data, row ):
    """Helper function. Sorts a numpy array by a given column. The return value is asorted data object."""
    data2 = array( data )
    data2 = data2[data2[:,row].argsort()]
    return data2
#END DEF sort_rows_________________________________________________________________________________


def white_gaussian( count, dims ):
    """Helper function. Creates a white gaussian. The return value is a 2d-numpy-array.
    
    Keyword arguments:		
    count -- int. how many samples.
    dims -- int. how many dimensions.    
    """
    result = []
    for i in xrange( dims ):
        result += [normal(0.0, 1.0, count)]
    result = array(result).T
    return result;
#END DEF white_gaussian____________________________________________________________________________


def gauss_likelihood( vector, center ): # inverse_epsilon, sqrt_determinant=None ): #add this if you want freely specify shape
    """Helper function. Computes the likelihood of the density specified through >>inverse_epsilon<< and
    >>sqrt_determinant<< and >>center<< at position >>vector<<. This function
    returns a lieklihood for every vector.
    
    supply >>inverse_epsilon<< and >>sqrt_determinant<< from a central place. This speeds
    up the performance:
    inverse_epsilon  = linalg.inv( Epsilon )
    sqrt_determinant = sqrt( abs( linalg.det( Epsilon ) ) )
    
    Keyword arguments:
    vector -- 2d-numpy-array which can contain a series of vectors (in rows)
    center -- 2d-numpy-array. vector containing the center position of the gaussian
    inverse_epsilon -- 2d--numpy-array. matrix with the inverse of the cov matrix
    sqrt_determinant -- float. square root of absolute determinant of the cov matrix
    """
    
    #add the following lines for more robustness
    #if type(center ) != ndarray: #this is true for 1D
    # center = array([[center]]);        

    j = vector - center;    
    d = len( center );
    #this is the fully correct version that allows for arbitrary cov matrix
    #b = transpose(exp( -0.5 * sum(j.T * dot(inverse_epsilon, j.T), 0) ) / ((2 * pi)**(d / 2.0) * sqrt_determinant));
    b = exp( -0.5 * sum(j.T**2, 0) ) / ((2 * pi)**(d / 2.0) );
    return b;
#END DEF gauss_likelihood________________________________________________________________________


def position_whites( count, positions ):
    """Helper function. Creates a dataset with labels, positions and probabilities from white gaussians
    which are positioned at >>positions<<. The shape of >>positions<< defines
    how many dimensions are output. >>count<< defines how many samples are generated
    per density. The return values are vecs, labels, probabilities
    
    Keyword arguments:
    count -- int. number of samples per density.
    positions -- 2d-numpy-array. height of it defines number of densities and width of it defines dimensionality.

    """
    k = positions.shape[0]
    inverse_epsilon = eye(k - 1);
    determinant = 1.0
    dims = positions.shape[1]
    white_one = white_gaussian(count, dims)
    vectors = tile( white_one, (k,1))	
    index = array(range(k*count)) / count #index contains 0,0,0,0, ... 1,1,1,1,1,1,....,2,2,2,2,2,.....,k-1,k-1,k-1,k-1,.... (total length is k*count) #serves as labels
    offsets = positions[index]            #tiles positions in such a way, that the same density is positioned at each k-simplex corner
    result_vectors = vectors + offsets    #actually move densities
    probabilities = [];
    for i in xrange( k ):
        ps = gauss_likelihood(result_vectors, array([positions[i]]) ); #compute probabilities
        probabilities += ps,
        pass;
        
    p = array(probabilities).T
    sums = p.sum(1);
    p /= array([sums]).T;
    return result_vectors, index, p
#END DEF position_whites___________________________________________________________________________


#FINAL IDEA USES LOOK UP TABLES AND LOGARITHMIC EXTRAPOLATION. NO SEARCH INVOLVED
def edge_length_of_k_simplex_lut( k, error):   
    """Compute edge length for a synthetic dataset with k white gaussian densities positioned
    at the vertices of a k-simplex. The dimensionality of the data is k-1.
    target_error specifies the the datasets' Bayes error rate.
    This version uses a look up table and extrapolation until k=500.
    
    Keyword arguments:
    k -- integer. how many gaussians?
    target_error -- float. value between 0.0 and 1.0
    """
    
    k = max(k,2);
    if (k > 100): #calculate y_shift by extrapolation
        y_shift = extrapolate_y_shift(k);
    else: #lookup table for k <= 100
        y_shift = Table_y_shift[k];
    #end if
    steepness = adapt_error_function(k,y_shift);    
    dist = modulated_error_function(error, y_shift, steepness, 1.)    
    return dist;
#END DEF edge_length_of_k_simplex_lut______________________________________________________________


def edge_length_of_k_simplex_amoeba( k, error, samples_for_optimization=1e6 ):
    """Compute edge length for a synthetic dataset with k white gaussian densities positioned
    at the vertices of a k-simplex. The dimensionality of the data is k-1.
    target_error specifies the the datasets' Bayes error rate.    
    This version uses a look up table and extrapolation until k=500.
    This method finds the y_shift using fast Bayes error computation method
    and amoeba optimization technique.
    
    Keyword arguments:
    k -- integer. how many gaussians?
    target_error -- float. value between 0.0 and 1.0
    samples_for_optimization -- integer. number of samples to be used by FastWGKSErrorModel
    """
    error_model = FastWGKSErrorModel( k, 0.5, samples_for_optimization ) #samples_per_density*k );  #optimize for 50% error
    y = amoeba( error_model.cost_function, 1 )[0]
    y_shift = error_model.convert_2_true_edge_length( y )
    steepness = adapt_error_function( k, y_shift );    
    d = modulated_error_function( error, y_shift, steepness, 1.)
    return d;
#END DEF edge_length_of_k_simplex_amoeba___________________________________________________________


def edge_length_of_k_simplex_numerical_descent( k, error, samples_for_optimization=1e6 ):
    """Compute edge length for a synthetic dataset with k white gaussian densities positioned
    at the vertices of a k-simplex. The dimensionality of the data is k-1.
    target_error specifies the the datasets' Bayes error rate.    
    This version uses a look up table and extrapolation until k=500.
    This method finds the y_shift using fast Bayes error computation method
    and gradient descent optimization technique based on numerical gradients.
    
    Keyword arguments:
    k -- integer. how many gaussians?
    target_error -- float. value between 0.0 and 1.0
    samples_for_optimization -- integer. number of samples to be used by FastWGKSErrorModel
    """
    error_model = FastWGKSErrorModel( k, 0.5, samples_for_optimization ) #samples_per_density*k );  #optimize for 50% error
    y = descent( error_model.cost_function, array([1.0]) )[0]
    y_shift = error_model.convert_2_true_edge_length( y )
    steepness = adapt_error_function( k, y_shift );    
    d = modulated_error_function( error, y_shift, steepness, 1.)
    return d;
#END DEF edge_length_of_k_simplex_numerical_descent________________________________________________


def k_white_gaussians(d, k, samples_per_density):   
    """Create a synthetic dataset with k white gaussians positioned at 
    corners of a k-simplex whose edges are d apart.
    
    Keyword arguments:
    d -- float. length of edge
    k -- int. number of simplex corners
    samples_per_density -- int. number of samples per white gaussian
    """
    
    n = max(k, 2)
    positions = setup_simplex(n, d)
    return position_whites(samples_per_density, positions) #will return tripe: (v:vectors,l:labels,p:posteriors)
#END DEF k_white_gaussians_________________________________________________________________________


def white_gaussians_on_k_simplex(k, target_error, samples_per_density, optimizer="lut", samples_for_optimization=1e6 ):
    """Create a synthetic dataset with k white gaussian densities positioned
    at the vertices of a k-simplex. The dimensionality of the data is k-1.
    target_error specifies the the datasets' Bayes error rate and 
    samples_per_density define how many values are sample from any gaussian.
    It is a conveniency function wrapping edge_length_of_k_simplex and k_white_gaussians.
    
    Keyword arguments:
    k -- integer. how many gaussians?
    target_error -- float. value between 0.0 and 1.0
    samples_per_density -- integer. how many samples per gaussian?
    sigma -- float. spreading constant for cross-entropy (default=10.0)
    elite_size -- int. how many elites are taken from the population for seeding next population (default=20)
    values -- int. size of cross-entropy population (default=100)
    """
    if optimizer.lower() == "lut":
        d = edge_length_of_k_simplex_lut(k, target_error );
    if optimizer.lower() == "amoeba":
        d = edge_length_of_k_simplex_amoeba( k, target_error, samples_for_optimization );
    if optimizer.lower() == "descent":
        d = edge_length_of_k_simplex_numerical_descent( k, target_error, samples_for_optimization );

    return k_white_gaussians( d, k, samples_per_density );
#END DEF white_gaussians_on_k_simplex______________________________________________________________











#==================================================================================================
#TEST CASES
#==================================================================================================
"""The following section defines test cases"""
if __name__ == "__main__":
    
    print "perforiming selftest of module"
    v,l,p = white_gaussians_on_k_simplex( 10, 0.3, 100, "descent" )

    
    #test case 1
    test_res = array([[0.0,0.0,0.0 ],[3.0,0.0,0.0],[1.5,2.59807621,0.0],[1.5,0.8660254,2.44948974]]);
    x = setup_simplex(4, 3.0);
    if sum(x - test_res) > 0.001:
        raise Exception( "problem with setup_simplex" )
    else: print "setup_simplex passed!"

    
    #test case 2
    sorted_res = array([[0.0,0.0,0.0],[1.5,2.59807621,0.0],[1.5,0.8660254,2.44948974],[3.0,0.0,0.0]])
    x = sort_rows(test_res, 0)
    if sum(x - sorted_res) > 0.001:
        print "if this test failes, then try one more time"
        raise Exception( "problem with test_res" )
    else: print "sort_rows passed!"

    #test case 3
    x = white_gaussian(10000, 20);
    if x.shape != (10000, 20):
        raise Exception( "problem with white_gaussian (1)" )
    if sum(mean(x, 0) - zeros(20) ) > 0.3:
        print "if this test failes, then try one more time"
        print sum( mean(x, 0) - zeros(20) )
        raise Exception( "problem with white_gaussian (2)" )	
    if sum(cov(x.T) - eye(20) ) > 0.3:
        print "if this test failes, then try one more time"
        print sum( cov(x.T) - eye(20) )
        raise Exception( "problem with white_gaussian (3)" )	
    print "white_gaussian passed"
    
    #test case 4
    x = rand( 10, 2);
    y = gauss_likelihood( x, array([[0,0]]) )
    if len( y ) != 10:
        raise Exception( "problem with gauss_likelihood!" )
    print "gauss_likelihood passed!"

    #test case 5
    x, l, p = position_whites( 10, array([[0,0],[10,0],[0,10]]) )
    if x.shape != (30,2):
        raise Exception( "problem with position_whites (1)" )    
    if len( l ) != 30:
        raise Exception( "problem with position_whites (2)" )
    print "position_whites passed!"
            
    v, l, p = white_gaussians_on_k_simplex( 20, 0.1, 100 )
    if v.shape != (2000,19):
        print v.shape
        raise Exception( "problem with white_gaussians_on_k_simplex (1)" )    
    if len( l ) != 2000:
        print len( l ) 
        raise Exception( "problem with white_gaussians_on_k_simplex (2)" )
    print "white_gaussians_on_k_simplex passed!"


#==================================================================================================
#END OF FILE
#==================================================================================================

#==================================================================================================
#White Markov Chain Generator WMCG
#Authors: Aleksander Lodwich, Janick Frasch and Thomas M. Breuel
#Remark: from the PaREn Project. 
#Refer to "Practical Bayes-True Data Generators For Evaluation of 
#          Machine Learning, Pattern Recognition and Data Mining Methods"
#
#This code is under MIT licence.
#Copyright (c) 2009, DFKI
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of 
#this software and associated documentation files (the "Software"), to deal in 
#the Software without restriction, including without limitation the rights to use, 
#copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
#Software, and to permit persons to whom the Software is furnished to do so, 
#subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
#FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
#COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
#IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
#CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#==================================================================================================

#==================================================================================================
#INCLUDES
#==================================================================================================


ENABLE_VISUALIZATION = 0  #0 is default

#==================================================================================================
#FUNCTIONAL DEPENDENCIES:
#==================================================================================================
#
#                  gcg()                            wmcg()
#                   |                                 |
#                  / \                               / \
#                 /   \                             /   \
#                /     -- CLASS SkelettonSolution --     \
#                |                            |           |
#                |bayes_error_method_a/b()----+           |
#                |                            |           |
#                |        wmcg_posteriors()---+           |
#                |                            |           |
#                |    flesh_on_skeleton()-----+           |
#                |            |                           |
#                |         density_tube()                 |
#                |                                        |
#         gaussian_skeletton()                   grow_wmcg_skeletton()
#                |                                        |
#                |\                                      /|
#                | -----------gaussian()----------------- |
#                |                                        |
#          grow_skeletton()                              /|
#                |                                      / |
#                |\                                    / /
#                | ---------- sort_rows()-------------- /
#                 \                                    /
#                  ---------array_without_rows()-------


#==================================================================================================
#FUNCTIONS
#==================================================================================================
def sort_rows( data, row ):
    """Helper function. Sorts a numpy array by a given column. The return value is asorted data object."""
    data2 = array( data )
    data2 = data2[data2[:,row].argsort()]
    return data2
#END DEF sort_rows_________________________________________________________________________________


def array_without_rows( data, rows ):
    """Helper function. data is at least 2d numpy array and rows is a list of indices for rows
    to be extracted. At the same time the remaining rows are also returned in a separate object.
    """
    remaining = arange( 1, len(data)+1 )
    remaining[rows] = 0
    remaining = unique( remaining )[1:] - 1
    return data[rows], data[remaining]
#END DEF array_without_rows________________________________________________________________________


def get_indices( bool_vector ):
    return unique( concatenate( (array([0]), bool_vector * arange( 1, len(bool_vector)+1 ) ) ) )[1:]-1
#END DEF get_indices_______________________________________________________________________________    
        

def gaussian( count, sigma ):
    """Basic function. Returns samples from a multivariate gaussian density.

    Keyword Arguments:
    count:  int>0: how many samples do you need?
    sigma:  2d square array: what is the covariance matrix?
    """
    dims = sigma.shape[0]

    result = []
    for i in xrange( dims ):
        result += [random.normal(0.0, 1.0, count)]
    result = array(result).T

    amp, vecs = linalg.eig( sigma )
    transform = (vecs.T*amp)
    result = dot( transform, result.T ).T
    return result;
#END DEF gaussian__________________________________________________________________________________


def grow_skeletton( vectors, no_of_chains, length, wished_angle=0, speed=1e-3 ):
    """grow_skeletton grows skelettons from a pool of predefined allowed vertices supplied by vectors.
    The vectors can be provided by any distribution of one own's like. The only
    restriction is that the number of provided vectors must be large than no_of_chains*length.
    This function smooths the created curves according to wished_angle and speed.
    The smaller the angle (expressed in degrees) and the higher the speed,
    the smoother the curves. The purpose of this growing function is to control the
    areas of high path crossing.

    Keyword Arguments:
    vectors:        2d array of size=(random,dims). Prototype vertices.
    no_of_chains:   int>1: number of chains to be created
    length:         int>1: number of vertices to be created for every chain
    wished_angle:   float [0,180]: prefered level of curvature for every vertex
    speed:          float>0.0: regularization factor for trading off between closeness and angle of adjacent path sections.
    """
    angle = cos( wished_angle * pi/180 )
    v = copy( vectors )
    if len( v ) < no_of_chains * length:
        msg = "ERROR ON " + ctime() + " grow_skeletton had " + str( len( v ) ) + " seed vectors, but needed at least " + str( no_of_chains * length ) + "\n"
        log_file = open( "skeletton_errors.log", "a") 
        log_file.write( msg )
        log_file.close()
        raise Exception( msg )

    skeletton = zeros( (no_of_chains, vectors.shape[1], length ) )
    indices = random.permutation( arange( len( v ) ) )[:no_of_chains] 
    skeletton[:,:,0], v = array_without_rows( v, indices )

    #this for loops does a nearest neighbor search to the points in skeletton[:,:,0]
    for n in arange( no_of_chains ):
        new_dirs = v - skeletton[n,:,0]
        new_norms = sqrt(sum((new_dirs**2),1))[:,newaxis]
        indices = arange( len( v ) )[:,newaxis]
        choice_matrix = sort_rows( concatenate( (new_norms, indices, v ), 1 ), 0 ) #sort by norms
        skeletton[n,:,1], v = array_without_rows( choice_matrix[:,2:], array([0]) )#take closest so far        

    for d in arange( 2, length ):
        #compute the direction vectors for every snake
        last_dirs = skeletton[:,:,d-1] - skeletton[:,:,d-2]
        last_norms = sqrt(sum((last_dirs**2),1))
        last_dirs/=last_norms[:,newaxis]
        for n in arange( no_of_chains ): #for every snake do the following:
            #1. estimate directions to all yet possible points in v
            new_dirs = v - skeletton[n,:,d-1]
            new_norms = sqrt(sum((new_dirs**2),1))
            new_dirs /= new_norms[:,newaxis]
            #2. compute a cost function based on "speed" and the angle
            costs = ( sum(last_dirs[n,:]*new_dirs,1)[:,newaxis] - angle )**2 + ( new_norms / speed )[:,newaxis]
            indices = arange( len( v ) )[:,newaxis]
            #3. pick vector that has the lowest cost
            choice_matrix = sort_rows( concatenate( (costs, indices, v ), 1 ), 0 )
            skeletton[n,:,d], v = array_without_rows( choice_matrix[:,2:], array([0]) ) #this will reduce v in size
    return skeletton
#END DEF grow_skeletton____________________________________________________________________________


def grow_wmcg_skeletton( chain_seed_vectors, length, wished_angle=0, speed=0.1, test_samples=100, fix_speed=0, fix_angle=0, resample=1 ):
    """grow_wmcg_skeletton. This function will create a 3D array of values where 1st dim is the number of paths, where 2nd dim is
    the number of features and 3rd dim is the number of path vertices. The bending and distribution of the chains can be controlled
    by the following parameters:

    Keyword Arguments:
    chain_seed_vectors:     2d array of size=(no_of_chains,no_of_dims). Contains starting points for every chain.
    length:                 int>0. How many vertices shall be generated for every chain?
    wished_angle:           float [0.0,180.0]. Depending on fix_angle is interpreted in the following two ways:
                                fix_angle=1: find random directional vectors that are most closely different by this angle from the current direction
                                fix_angle=0: find random directional vectors that are at most different by this angle from the current direction
    speed:                  float>0.0: scales the length of each chain component by this factor.
    test_samples:           int>0: defines how many directions are sampled. The more the finer the model
    fix_speed:              0/1: if 1 then all chains' length=speed
    fix_angle:              0/1: if 1 then angle between current direction and new direction is defined by wished_angle
    resample:               0/1: if 1 then test samples will be resampled before every new vertex is computed
    """

    angle              = cos( wished_angle * pi/180 ) #transfer degree values into radial value
    dims               = chain_seed_vectors.shape[1]  #how many feature dimensions do we have?
    vector_source      = gaussian( test_samples, eye( dims )) #generate a prototype of all directions and speeds
    vector_source_norm = vector_source * sqrt( sum( vector_source**2, 1 ) )[:,newaxis] #only directions and speed =1
    vector_source_adj  = vector_source_norm * speed; #uniformely distributed sphere of directions and speed=speed
    indices            = arange( test_samples )
    no_of_paths        = chain_seed_vectors.shape[0] #how many paths are requested?

    #create the first two vertices of any path:
    skeletton          = zeros( (no_of_paths, dims, length ) )
    skeletton[:,:,0]   = chain_seed_vectors;
    skeletton[:,:,1]   = chain_seed_vectors + vector_source_adj[random.permutation(indices)[:no_of_paths]];
 
    #create the rest of the vertices of any path:
    for d in arange( 2, length ):
        vector_source      = gaussian( test_samples, eye( dims ) ) #white density with normally distributed speeds and uniformely distributed directions
        vector_source_norm = vector_source / sqrt( sum( vector_source**2, 1 ) )[:,newaxis] #speeds are constant
        if fix_speed:
            vector_source_adj  = vector_source_norm * speed; #uniformely distributed sphere of directions with speed=speed
        else:
            vector_source_adj  = vector_source * speed; #uniformely distributed sphere of directions with speed=N()*speed

        #compute the direction vectors for every snake
        last_dirs = ( skeletton[:,:,d-1] - skeletton[:,:,d-2] )
        last_dirs /= sqrt( sum( last_dirs**2, 1 ) )[:,newaxis] #we get unit vectors, this is important for the dot product later
        for n in arange( no_of_paths ): #for every snake do the following:
            #1. estimate directions to all yet possible points in v
            new_dirs = vector_source_norm #that's cheap
            #2. compute a cost function based on "speed" and the angle
            if not fix_angle:
                #accept angle in range [angle,1]
                costs = (maximum( 0, angle - sum(last_dirs[n,:]*new_dirs,1) ) + ( rand( test_samples ) * 1e-3 ))[:,newaxis] #make sure there's enough randomness for sort
            else:
                #accept angles ~ [angle-noise,angle+noise]
                costs = ( sum(last_dirs[n,:]*new_dirs,1)[:,newaxis] - angle )**2

            #3. pick vector that has the lowest cost
            choice_matrix = sort_rows( concatenate( (costs, indices[:,newaxis], vector_source_adj+skeletton[n,:,d-1] ), 1 ), 0 )

            skeletton[n,:,d], garbage = array_without_rows( choice_matrix[:,2:], array([0]) ) #only pick the best vector array([0])=0
    return skeletton
#END DEF grow_wmcg_skeletton_______________________________________________________________________


def gaussian_skeletton( count, sigma, no_of_chains, length, wished_angle=0, speed=1e-3 ):
    """gaussian_skeletton. This function generates a skeletton from a prototype normal
    distribution. The number of crossings of the chains increases in the center and
    decreases outwards.

    Keyword Arguments:
    count:          int>0: how many prototypes to use?
    sigma:          2d square array: what is the covariance matrix of the prototype distribution?
    no_of_chains:   int>1: how many chains shall be generated?
    length:         int>1: how many vertices shall exist in every chain?
    wished_angle:   float[0,180]: what is the target angle between two adjacent path sections?
    speed:          float>0:  what is the regularization factor for the tradeoff between angle and vertex distance?
    """
    g = gaussian( count, sigma )
    return grow_skeletton( g, no_of_chains, length+1, wished_angle, speed )
#END DEF gaussian_skeletton________________________________________________________________________


def density_tube( length, dims, count, sigma ):
    """Helper Function. density_tube generates a "tube" of sphericaly distributed samples
    around dim 0 for the length of length. The density along dim0 is controlled via
    longitudianl_density and sigma controlls the "thickness" of the tube. The tube
    always starts at vec=0. The tube has to be transformed to the proper place later.

    Keyword Arguements:
    length:     float>0.0: how lang shall the tube be?
    dims:       int>0: how many dimensions does the problem have?
    count:      int>0: how many samples shall be generated?
    sigma:      float>0: how "wide" is the tube? Real width is infinite of course.
    """
    result = zeros( ( count, dims ) )
    result[:,1:] = random.normal( scale=sigma, size = ( count, dims-1 ) ) #first dim must remain zero
    if count > 0:
        result[:,0] = rand( count ) * length #stretch samples along length
    return result
#END DEF density_tube______________________________________________________________________________


def flesh_on_skeletton( skeletton, total_count, sigma ):
    """flesh_on_skeletton is one of the core functionality. It basically puts samples
    around the skeletton paths and delivers a new dataset with ground truth labels.

    Keyword Arguments:
    skeletton:              3d array of size=(no_of_chains,no_of_dims,chain_length): as can be grown using grow_skeletton()
    total_count:            int>>1. How many samples shall be generated?
    sigma:                  float>0.0. How "wide" are the chains?
    """
    sigma = max( 1e-10, sigma )
    dims = skeletton.shape[1]
    sections = skeletton.shape[2]-1
    snakes = skeletton.shape[0]

    #compute total length and create a sampling plan for the
    total_length = 0
    lengths = zeros( snakes * sections ) #segment probabilities
    seg_p   = zeros( snakes * sections ) #segment probabilities
    for n in arange( snakes ):
        for section in arange( sections ):
            path_vec = skeletton[n,:,section+1]-skeletton[n,:,section][newaxis,:]
            length = linalg.norm( path_vec )
            i = n * sections + section
            lengths[i] = length
    seg_p = (lengths / sum(lengths))
    samples = ( seg_p * total_count ).round()
    samples[0] += total_count - sum(samples) #stuff missing samples

    #in this section we'll generate the samples around the skeletton
    vectors = {}
    for n in arange( snakes ):
        for section in arange( sections ):
            i = n * sections + section
            path_vec = skeletton[n,:,section+1]-skeletton[n,:,section][newaxis,:]
            tube = density_tube( 1.0, dims, samples[i], sigma )
            V = linalg.svd(path_vec)[2]            
            V[0] = path_vec #assure that the path vector is oriented correctly
            transformation = V.T
            aligned_tube = dot( transformation, tube.T ).T + skeletton[n,:,section][newaxis,:]
            vectors[n] = concatenate( ( vectors.get( n, zeros((0,dims))), aligned_tube ) )

    #in this ection we'll compact the dictionary into a single dataset  
    #TODO: we're growing result and labels which can be somewhat inefficient!  
    result = zeros( (0, dims) )
    labels = zeros( 0 )
    label_index = 0
    for v in vectors.values():
        result = concatenate( ( result, v ) )
        labels = concatenate( ( labels, ones( len( v ) )*label_index ) )
        label_index += 1  

    return result, labels
#END DEF flesh_on_skeletton________________________________________________________________________


def wmcg_posteriors( samples, skeletton, sigma ):
    """wmcg_posteriors computes the posterior probabilities for a wmcg model based on the skeletton
    and the sigma. Posteriors are computed for every vector in samples.

    Keyword Arguments:
    samples:    2d array. vectors are rows
    skeletton:  3d array. dim0: chains dim1:features dim2:vertices of chains
    sigma:      float>0. width of chains
    """
    paths  = skeletton.shape[0]
    joints = skeletton.shape[2]-1
    dims   = skeletton.shape[1]
    sample_count = samples.shape[0]

    posteriors = zeros( (sample_count,paths) )
    #for vec_index in arange( samples ):
    for path_index in arange( paths ):
        for joint_index in arange( joints ):
            step_vector   = skeletton[path_index,:,joint_index+1] - skeletton[path_index,:,joint_index]
            length        = linalg.norm( step_vector )
            direction     = ( step_vector / length )[newaxis,:]
            local_samples = copy( samples ) - skeletton[path_index,:,joint_index][newaxis,:]
            dot_products  = sum( local_samples * direction, 1 )
            involved_vecs = float32( ( dot_products >= 0.0 ) & ( dot_products <= length ) )
            hypotenuse    = sum( local_samples**2 ,1) #entf**2 is already squared
            distances     = sqrt( hypotenuse - dot_products**2 ) #therefore you need to do it here
            likelihoods   = exp( -0.5 * distances**2 / sigma )
            posteriors[:,path_index] += likelihoods * involved_vecs   #at first these are likelihoods        
    #end for
    
    posteriors /= sum( posteriors, 1 )[:,newaxis]+1e-308 #now these are posteriors
    return posteriors;
#END DEF wmcg_posteriors___________________________________________________________________________


def bayes_error_method_a( l1, l2 ):
    """computes the Bayes error by comparing l1 (ground truth) and l2 (estimated labels)"""
    return 1.0 - mean( l1 == l2 )
#END DEF bayes_error_method_a______________________________________________________________________


def bayes_error_method_b( probabilities ):
    """computes the Bayes error by probability mass integration."""
    return 1.0 - mean( probabilities.max(1) ) #compute Bayes error according to method (B)
#END DEF bayes_error_method_b______________________________________________________________________



if ENABLE_VISUALIZATION:
    glob_fig = None
    def drawt( s, v, l, y_lim=[-10,10], x_lim=[-10,10], wait=3 ):
        """drawt is a DrawTranslator() function replacement"""
        global glob_fig
        ion()
        if glob_fig is None:
            glob_fig = figure(figsize=(15,15))
        glob_fig.clear()
        glob_fig.show()
        d = len(s)
        hold( 'on' )
        for k in range( d ):
            selected = get_indices( int32( l == k ) )
            plot( v[selected,0], v[selected,1], '.' )        
        for k in range( d ):
            plot( s[k,0,:], s[k,1,:] )
            plot( s[k,0,:], s[k,1,:],'o' )
        ylim(y_lim);xlim(x_lim)
        hold( 'off' )
        sleep(wait)
#END DEF drawt_____________________________________________________________________________________


class SkelettonSolution:
    """SkelettonSolution is a cookie class for keeping all the extra constants
    needed to compute the Bayes error in the cost_function.
    """

    def __init__( self, skeletton, target_error, total_samples=1000 ):
        self.my_skeletton = skeletton
        self.my_target_error = target_error
        self.my_total_samples = total_samples
        self.my_target_samples_count = 10000 #tmp
        result = amoeba( self.cost_function, 1, initial_values=array([[0.9],[1.1]]), abort_under_cost=1e-4 )
        if abs( self.my_bayes_error - target_error ) > 0.02:
            msg = "ERROR ON " + ctime() + " target error was missed. target is " + str(target_error) + " and achieved was " + str( self.my_bayes_error ) + "\n"
            log_file = open( "skeletton_errors.log", "a" )
            log_file.write( msg )
            log_file.close()
            raise Exception( msg )
        sys.stdout.flush()
    #END DEF __INIT__
   

    def cost_function( self, sigma_in_list ):
        """the form of the function is required by the optimizers and cannot be changed"""
        self.my_sigma = sigma_in_list[0]
        if self.my_sigma <= 0.0:
            return 1.0;
        #else:
        self.my_samples, self.my_labels = flesh_on_skeletton( self.my_skeletton, self.my_total_samples, self.my_sigma )
        self.my_posteriors = wmcg_posteriors( self.my_samples, self.my_skeletton, self.my_sigma )
        self.my_bayes_error = bayes_error_method_a( self.my_labels, argmax( self.my_posteriors,1 ) )
        #DEBUG SECTION
        if ENABLE_VISUALIZATION:
            drawt( self.my_skeletton, self.my_samples, self.my_labels )
            print "[sigma,total_samples,samples,error]=", self.my_sigma, self.my_total_samples, len(self.my_samples), self.my_bayes_error
            print "cost of error:", ( self.my_target_error - self.my_bayes_error )**2
        #CREATE REFERENCE VARIABLES FOR CONVENIENCE IN gnerators.py AND THEY DO NOT COST EXTRA MEMORY
        self.s = self.my_skeletton
        self.v = self.my_samples
        self.l = self.my_labels
        self.p = self.my_posteriors
        return 100*( self.my_target_error - self.my_bayes_error )**2 
    #END DEF cost_function


    def __str__( self ):
        return "error:" + str(self.my_bayes_error) + " at sigma:" + str(self.my_sigma)
    #END DEF __STR__
#END DEF CLASS SkelettonSolution___________________________________________________________________




def gcg( target_error, seeds=150, seed_sigma=eye(2)*5, no_of_chains=10, chain_lengths=15, target_angle=0, speed=1e-0, total_samples=1000 ):
    """gcg generates a gaussian chain generator dataset.

    Keyword Arguments:
    target_error:       float[0,1]. what shall the Bayes error for the dataset be?
    seeds:              int>>1. how many seed starting points shall be generated on a normal distribution?
    seed_sigma:         2d square array. covariance matrix for the normal seed distribution
    no_of_chains:       int>1. how many chains shall be generated?
    chain_lengths:      int>1. how many vertices shall every chain have?
    target_angle:       float[0,180]. what is the angle between adjacent path sections?
    speed:              float>0. regularization parameter for making curves smoother
    total_samples:      int>>1. What is the number of vectors you want to generate?
    """
    s = gaussian_skeletton( seeds, seed_sigma, no_of_chains, chain_lengths, target_angle, speed )
    result = SkelettonSolution( s, target_error, total_samples )
    return s, result.my_samples, result.my_labels, result.my_posteriors
#END DEF gcg_______________________________________________________________________________________


def scg( target_error, radius=10.0, seeds=150, seed_sigma=eye(3)*5, no_of_chains=10, chain_lengths=10, target_angle=0, speed=1e-0, total_samples=1000 ):
    """gcg generates a spheric chain generator dataset. Around an spheric-like structure 
    you have highest sample density and the core is rather empty.

    Keyword Arguments:
    target_error:       float[0,1]. what shall the Bayes error for the dataset be?
    seeds:              int>>1. how many seed starting points shall be generated on a normal distribution?
    seed_sigma:         2d square array. covariance matrix for the normal seed distribution
    no_of_chains:       int>1. how many chains shall be generated?
    chain_lengths:      int>1. how many vertices shall every chain have?
    target_angle:       float[0,180]. what is the angle between adjacent path sections?
    speed:              float>0. regularization parameter for making curves smoother
    total_samples:      int>>1. What is the number of vectors you want to generate?
    """
    s = gaussian_skeletton( seeds, seed_sigma, no_of_chains, chain_lengths, target_angle, speed )
    s *= radius/sqrt( sum( s**2, 1 ) )[:,newaxis,:] #normalize
    result = SkelettonSolution( s, target_error, total_samples )
    return s, result.my_samples, result.my_labels, result.my_posteriors
#END DEF gcg_______________________________________________________________________________________


def wmcg( target_error, seed_sigma=eye(2)*2, no_of_chains=10, chain_lengths=10, target_angle=180.0, 
            speed=1e-0, test_samples=1000, total_samples=1000,
            fix_speed=0, fix_angle=0, resample=1 ):
    """wmcg is a function that generates white markov chain datasets with a specifiec Bayes error rate.
    It can control the angles of the random process. Seit target_angle to 180.0 deg in order to obtain
    a Wiener process.

    Keyword Arguments:
    target_error:       float[0,1]. The target Bayes error rate of the new dataset.
    seed_sigma:         2d square array. Covariance matrix of the seeds for the chains
    no_of_chains:       int>1. How many chains shall be generated?
    chain_lengths:      int>1. How many chain-vertices shall be generated (length of chain)?
    target_angle:       float[0,180]. What is the cone of angle restriction?
    speed:              float>0.0. scaling factor for the chains
    test_samples:       int>>1. number of samples for direction sampling. low values cause crude direction changes.
    total_samples:      int>>1. What is the number of vectors you want to generate?
    fix_speed:          0/1. If yes(1), then chain sections are of equal length
    fix_angle:          0/1. If yes(1), then angle lie on the angle-cone    
    """
    g = gaussian( no_of_chains, seed_sigma )
    s = grow_wmcg_skeletton( g, chain_lengths, target_angle, speed, test_samples, fix_speed, fix_angle, resample )
    result = SkelettonSolution( s, target_error, total_samples )
    return s, result.my_samples, result.my_labels, result.my_posteriors
#END DEF wmcg______________________________________________________________________________________









#==================================================================================================
#TEST CASES
#==================================================================================================
""" Test Cases 

def debug_function_1():
    d = 10
    g = gaussian( 1000, eye(2) )
    s = grow_skeletton( g, d, 40, 0.0, 1e-3 )

    plot(  g[:,0], g[:,1], "." )
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:] )
    ylim([-5,5]);xlim([-5,5])
    show()

def debug_function_3():
    g = density_tube( 1.0, 2, 100.0, 0.1 )
    path_vec = array([[-3,1]])
    V = svd(path_vec)[2]            
    V[0] = path_vec #assure that the path vector is oriented correctly
    transformation = V.T
    g = dot( transformation, g.T ).T + array([10,0])
    plot(  g[:,0], g[:,1], "." )
    show()

def debug_function_2():
    d = 3
    g = gaussian( 1500, eye(2)*5 )
    s = grow_skeletton( g, d, 500, 20.0, 1e+1 )
    v,l = flesh_on_skeletton( s, 100.0, 0.1 )
    t = Translator( v )
    t.SetLabel( l.tolist() )
    print l
    DrawTranslator( t )
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:] )
        plot( s[k,0,:], s[k,1,:],'x' )
    #ylim([-2,2]);xlim([-2,2])
    sleep( 10 )


def debug_function_4():
    d = 10
    sigma = 0.05
    g = gaussian( 1500, eye(2)*2 )
    s = grow_skeletton( g, d, 60, 0.0, 1e+1 )
    if 0: #if mesh version
        X,Y = meshgrid( frange(-10,10,0.1), frange(-10,10,0.1) )
        x = X.flatten()
        y = Y.flatten()
        v = concatenate( (x[:,newaxis],y[:,newaxis]), 1 )
    else:
        v,l = flesh_on_skeletton( s, 100.0, sigma )    
    p = wmcg_posteriors( v, s, sigma )
    l2 = argmax( p, 1 )
    print "Bayes Error:", bayes_error_method_a( l, l2 )
    t = Translator( v )
    t.SetLabel( l2.tolist() )
    figure( figsize=(15,15) )
    DrawTranslator( t )
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:] )
        plot( s[k,0,:], s[k,1,:],'o' )
    ylim([-10,10]);xlim([-10,10])
    
    sleep( 10 )

def debug_function_5():
    s = gaussian_skeletton( 150, eye(2)*2, 10, 5, 0.0, 1e-1 )
    x = SkelettonSolution( s, 0.3 )
    print x


def debug_function_6():
    d=10
    s, v,l,p = gcg( 0.05,no_of_chains=d )
    t = Translator(v)
    t.SetLabel( l.tolist() )
    figure( figsize=(15,15))
    DrawTranslator( t )
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:] )
        plot( s[k,0,:], s[k,1,:],'o' )
    ylim([-10,10]);xlim([-10,10])
    sleep(10)


def debug_function_7():
    d = 3
    g = gaussian( 5, eye(2)*2 )
    s = grow_wmcg_skeletton( g, 15, 45.0, 1e+0 )
    v,l = flesh_on_skeletton( s, 100.0, 0.01 )
    t = Translator( v )
    t.SetLabel( l.tolist() )
    DrawTranslator( t )
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:] )
        plot( s[k,0,:], s[k,1,:],'x' )
    #ylim([-2,2]);xlim([-2,2])
    sleep( 10 )


def debug_function_8():
    d = 10
    s, v,l,p = wmcg( 0.25, seed_sigma=eye(2)*2, no_of_chains=d, chain_lengths=15, target_angle=45.0, test_samples=15, total_samples=1050 )
    t = Translator(v)
    t.SetLabel( l.tolist() )
    figure( figsize=(15,15))
    DrawTranslator( t )
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:] )
        plot( s[k,0,:], s[k,1,:],'o' )
    ylim([-10,10]);xlim([-10,10])
    sleep(10)

debug_function_1()
debug_function_2()
debug_function_3()
debug_function_4()
debug_function_5()
debug_function_6()
debug_function_7()
debug_function_8()
"""
#==================================================================================================
#Random Transformations Module
#Authors: Aleksander Lodwich, Janick Frasch and Thomas M. Breuel
#Remark: from the PaREn Project. 
#Refer to "Practical Bayes-True Data Generators For Evaluation of 
#          Machine Learning, Pattern Recognition and Data Mining Methods"
#
#This code is under MIT licence.
#Copyright (c) 2009, DFKI
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of 
#this software and associated documentation files (the "Software"), to deal in 
#the Software without restriction, including without limitation the rights to use, 
#copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
#Software, and to permit persons to whom the Software is furnished to do so, 
#subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
#FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
#COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
#IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
#CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#==================================================================================================


#==================================================================================================
#INCLUDES
#==================================================================================================


#==================================================================================================
#FUNCTIONS
#==================================================================================================


def random_rotation_matrix( dimensions ):
    """ Creates a random rotation matrix in >>dimensions<< dimensions.
    RETURNS Array of a random rotation matrix

    Keyword Arguments:    
    dimensions:	No. of (external) dimensions for the rotation matrix
    """
    A   = white_gaussian( dimensions, dimensions );
    Q,R = linalg.qr(A);
    sgn = sign(rand()-.5);    
    return sgn*Q;
#end def random_rotation_matrix____________________________________________________________________


def random_translation_vector( dimensions, type = "uniform", scale = 1.0 ):
    """Creates a random vector for translations in >>dimensions<< dimensions.
    RETURNS Array of a random translation vector
    
    Keyword Arguments:
    dimensions:	No. of (external) dimensions for the translation vector
    type:          Either "uniform" or "gauss"
    scale:         scale factor for the maximal Translation respectively standard deviation when chosen 
                   Gaussian
    """
    if type == "uniform":
        Translation = rand( dimensions ) * scale;
    elif type == "gauss":
        Translation = normal(0., scale, dimensions);
    else:
        print "ERROR: type has to be either 'unif' or 'gauss'. Zero translation vector has been returned!";
        Translation = zeros(dimensions);
    #end if
    
    return Translation[newaxis,:];
#end def random_translation_vector_________________________________________________________________


def random_scaling_vector(dimensions, sigma=1.0 ):
    """Creates a random scaling vector in >>dimensions<< dimensions with sigma >>sigma<<.
    RETURNS Array of a random scaling matrix

    Keyword Arguments:
    dimensions:	No. of (external) dimensions for the scaling matrix
    sigma:         standard deviation as measure for the factor of scaling
    """
    return exp( normal(0., sigma, dimensions) )[newaxis,:]
#end def rand_scaling_vector_______________________________________________________________________


def random_shearing_matrix( dimensions, sigma_list = [1.]):
    """Creates a random shearing matrix for len(sigma_list) dimensions in a >>dimensions<< dimensional space.

    Keyword Arguments:
    dimensions:	No. of (external) dimensions for the scaling matrix
    sigma_list:    list standard deviations as measure for the shearing factor; the length of the list
                   determines the number of shearing operations (has to be less than n*(n-1) for n dimensionality
    """

    #build index list
    possible_indices = [];
    for i in range(dimensions):
        for j in range(dimensions):
            if j != i:
                possible_indices += [(i,j)];
            #end if
        #end for
    #end for
    shearing_indices = permutation(possible_indices)[:len(sigma_list)];
    
    #build shearing matrix
    shearing_matrix = diag(ones(dimensions));
    for k in range(len(sigma_list)):
        i = shearing_indices[k][0];
        j = shearing_indices[k][1];
        
        shearing = normal(0., sigma_list[k]);
        shearing_matrix[i][j] = shearing;
    #end for
    
    return shearing_matrix;
#end def random_shearing_matrix____________________________________________________________________


def extend_dimensionality( vectors, target_dimensionality ):
    """extend_dimensionality embeds vectors into a higher dimensional space.
    
    Keyword Arguments:
    vectors:                    2d array. vectors are in rows
    target_dimensionality:      int>=dim(vecs). number of dimensions of the high dimensional space
    """
    if vectors is None:
        return None
    result = zeros( ( vectors.shape[0], target_dimensionality ) )
    result[:,:vectors.shape[1]] = vectors
    return result
#end def extend_dimensionality_____________________________________________________________________


def transform_by_matrix( vex, new_coordinate_system ):
    """applies regular affine transforms"""
    return dot( new_coordinate_system, vex.T ).T
#end def transform_by_matrix_______________________________________________________________________


def transform_by_cov( vecs, epsilon ):
    """puts a covariance on top"""
    EigenDescription    = eig( epsilon );                                      #Calculate destortion directions
    Transformation      = EigenDescription[1]  * sqrt(EigenDescription[0]);    #make transformation from white gauss to target gauss
    NormalDistribution  = dot( Transformation, vecs.T ).T;                     #apply transformation
    return NormalDistribution;                                                 #return vector population
#end def transform_by_cov__________________________________________________________________________


def apply_cov_matrix( vecs, new_sigma, related_vector_sets = [] ):
    """changes the sigma of the data, but not its centroid"""
    center = mean( vecs, 0 )[newaxis,:]
    vecs -= center
    vs, vv = eig(cov( vecs.T ))
    M1 = linalg.inv((vv*sqrt(vs)))
    whitened_vecs = dot( M1, vecs.T ).T
    vs, vv = eig( new_sigma )
    M2 = (vv*sqrt(vs))
    final_vecs = dot( M2, whitened_vecs.T ).T + center

    transformed = [ final_vecs ]
    for vecs in related_vector_sets:
        vecs -= center
        whitened_vecs = dot( M1, vecs.T ).T
        final_vecs = dot( M2, whitened_vecs.T ).T + center
        transformed += [final_vecs]
    return transformed


#end def apply_cov_matrix__________________________________________________________________________


def recenter( vecs, new_center ):
    center = atleast_2d( new_center )
    return (vecs-mean(vecs,0))+center
#end def recenter


#==================================================================================================
#SELF TEST
#==================================================================================================
if __name__ == "__main__":
    print "3D random rotation matrix: ";
    print RandRotation(3);
    print "3D random uniform translation: ";
    print RandTranslation(3, "unif", 5.);
    print "3D random scaling matrix: ";
    print RandScaling(3, 5.);
    print "3D random shearing matrix: ";
    print RandShearing(3, [.5, 1]);
    
    #debug
    #print S;
    #Samples = rand(1000,3);
    #T1 = Translator(Samples);
    #T1.SetLabel("old")
    #T2 = Translator(dot(S, Samples.T).T);
    #T2.SetLabel("new")
    #figure()
    #DrawTranslator(T1 + T2,[0,1]);
    #figure()
    #DrawTranslator(T1 + T2,[0,2]);
    #figure()
    #DrawTranslator(T1 + T2,[1,2]);
    #show();
#end if

#==================================================================================================
#END OF FILE
#==================================================================================================

version = "DFKI Synthetic Data Generators Pack (WGKS/WMCG) V1.03, 2009"
authors = "Aleksander Lodwich (aleksander.lodwich@dfki.de), Janick Frasch (janick.frasch@gmail.com), Thomas Breuel (tmb@iupr.com)"
#==================================================================================================
#Wrapper Module for DFKI Bayes-True Data Generators
#-- This module guarantees explicit parameter logging and replayability of experiments.
#Read demo.py for how this module can be used. --
#Authors: Aleksander Lodwich, Janick Frasch and Thomas M. Breuel
#Remark: from the PaREn Project. 
#Refer to "Practical Bayes-True Data Generators For Evaluation of 
#          Machine Learning, Pattern Recognition and Data Mining Methods"
#
#This code is under MIT licence.
#Copyright (c) 2009, DFKI
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of 
#this software and associated documentation files (the "Software"), to deal in 
#the Software without restriction, including without limitation the rights to use, 
#copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the 
#Software, and to permit persons to whom the Software is furnished to do so, 
#subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all 
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
#FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR 
#COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER 
#IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
#CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#==================================================================================================


#==================================================================================================
#INCLUDES
#==================================================================================================


#==================================================================================================
#GLOBALS
#==================================================================================================
data_sets = {}
stack = []
transaction_id = 0

#==================================================================================================
#FUNCTIONS
#==================================================================================================

def execute( program=None ):    
    """execute will execute a list of lists (of list of ...) or of dictionaries in order to
    generate data. Resulting data can be found in the global dictionary "data_sets"
    
    Keyword Arguments:
    program:    list of lists or dictionaries.
    """
    global stack
    global data_sets
    if program is None:
        program = stack

    if type( program ) is list:
        for statement in program:
            execute( statement )

    if type( program ) is dict:
        cmd = program.get( "cmd", None )
        if cmd == "wgks":
            name                    = program.get( "name", "default"+str(len(data_sets)) )
            k                       = program.get( "no_of_densities", 3 )
            target_error            = program.get( "target_error", 0.1  )
            samples_per_density     = program.get( "samples_per_density", 1000 )
            optimizer               = program.get( "optimizer", "lut" )
            samples_for_optimization= program.get( "samples_for_optimization", 1e+6 )
            
            v,l,p = white_gaussians_on_k_simplex( k, target_error, samples_per_density, optimizer, samples_for_optimization )
            data_sets[name] = { "vectors":v, "labels":l, "probabilities":p}

        if cmd == "k_white":
            name                    = program.get( "name", "default"+str(len(data_sets)) )
            k                       = program.get( "no_of_densities", 3 )
            d                       = program.get( "distance", 0.1  )
            samples_per_density     = program.get( "samples_per_density", 1000 )
            v,l,p = k_white_gaussians( d, k, samples_per_density )
            data_sets[name] = { "vectors":v, "labels":l, "probabilities":p }

        if cmd == "solve":
            name                    = program.get( "name", "default"+str(len(data_sets)) )
            target_error            = program.get( "target_error", 0.1  )
            total_samples           = program.get( "total_samples", 1000.0 ) #100samples per metric unit
            skeletton               = program["skeletton"]

            r = SkelettonSolution( skeletton, target_error, total_samples )
            data_sets[name] = { "skeletton":r.s, "vectors":r.v, "labels":r.l, "probabilities":r.p, "dims":skeletton.shape[1] }

        if cmd == "embed":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            dims                    = program["dims"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}
            if source_skeletton is not None:
                result["skeletton"] = extend_dimensionality( source_skeletton, dims )
            if source_vectors is not None:
                result["vectors"]   = extend_dimensionality( source_vectors, dims )
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result
            
        if cmd == "rand_scale":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}            
            if source_skeletton is not None:
                result["skeletton"] = source_skeletton * program["random_scaling_vector"]
            if source_vectors is not None:
                result["vectors"]   = source_vectors * program["random_scaling_vector"]
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result
                
        if cmd == "rand_trans":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}            
            if source_skeletton is not None:
                result["skeletton"] = source_skeletton + program["random_translation_vector"]
            if source_vectors is not None:
                result["vectors"]   = source_vectors + program["random_translation_vector"]
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result


        if cmd == "rand_rot":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}
            if source_skeletton is not None:
                result["skeletton"] = scipy.dot( program["random_rotation_matrix"], source_skeletton.T ).T
            if source_vectors is not None:
                result["vectors"]   = scipy.dot( program["random_rotation_matrix"], source_vectors.T ).T
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result

        if cmd == "rand_shear":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}
            if source_skeletton is not None:
                result["skeletton"] = scipy.dot( program["random_shearing_matrix"], source_skeletton.T ).T
            if source_vectors is not None:
                result["vectors"]   = scipy.dot( program["random_shearing_matrix"], source_vectors.T ).T
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result

        if cmd == "recenter":
            source_name             = program["source_name"]  #must raise exceptions if is not there
            target_name             = program["target_name"]  #must raise exceptions if is not there
            new_centroid            = program["new_centroid"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}
            if source_skeletton is not None and source_vectors is None:
                result["skeletton"] = recenter( source_skeletton, new_centroid )
            if source_skeletton is None and source_vectors is not None:
                result["vectors"]   = recenter( source_vectors, new_centroid )
            if source_skeletton is not None and source_vectors is not None:
                off = new_centroid - mean( source_vectors, 0 )[newaxis,:]
                result["vectors"]   = source_vectors + off
                result["skeletton"] = source_skeletton + off
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result

        
        if cmd == "apply_cov":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            result                  =  {}

            if source_skeletton is not None and source_vectors is None:
                result["skeletton"] = apply_cov_matrix( source_skeletton, program["new_sigma"] )[0]
            if source_vectors is None and source_skeletton is not None:
                result["vectors"]   = apply_cov_matrix( source_vectros, program["new_sigma"] )[0]
            if source_vectors  is not None and source_skeletton is not None:
                result["vectors"], result["skeletton"] = apply_cov_matrix( source_vectros, program["new_sigma"], [source_skeletton] ) #source_skeletton will be transformed exactly the same way as source_vectors
            if source_labels is not None:
                result["labels"]    = source_labels
            if source_probabilities is not None:
                result["probabilities"] = source_probabilities
            data_sets[target_name]  = result

        if cmd == "flush":
            export_data_sets( program["what"], program["exporter"] )
            data_sets = {}


#end def execute___________________________________________________________________________________            


def str_matrix( m ):
    """formats a single line python call that can rebuild the matrix via eval()"""
    result = "array( "

    if m.ndim > 1:
        result += "["
        for item in m:
            result += str_matrix( item ) + ","
        result += "]"
    elif m.ndim==1:
        result += "["
        for item in m:
            result += str( item ) + ","
        result += "]"
    return result + ")"
#end def str_matrix________________________________________________________________________________


def age_file( filename ):
    """if filename exists, then it will be renamed to reflect
    that it is not the newest version."""
    name_parts = string.split( filename, "." )
    try:
        index = int( name_parts[-1] )
        name_parts[-1] = str( index+1 )
    except:
        name_parts += ["1"]
    aged_name = string.join( name_parts, "." )

    if os.access( filename, os.R_OK ):
        age_file( aged_name )
        os.system( "mv " + filename + " " + aged_name )
#end def age_file__________________________________________________________________________________
        

def compile2file( source_filename, open_target_filehandle ):
    """copies the python source in source_filename to the already open python file in
    open_target_filehandle. It removes specific lines of code:
    1. from wgks import *
    2. from wmcg import *
    3. from transforms import *
    4. from version import *
    5. from normal_density import *
    6. from optimizers import *
    7.     from lut import *
    """
    try:
        f = open( source_filename, "r" )
    except:
        for path in sys.path:
            try:
                f = open( os.path.join( path, source_filename), "r" )
            except: pass
        try:
            f
        except:
            print "could not find", source_filename
            exit(-1)
            
    for line in f:
        #if line[:-1] in [ "from wgks import *", "from transforms import *", "from wmcg import *", 
        #                "from version import *", "from normal_density import *", "from optimizers import *",
        #                "    from lut import *"]:
        #    continue;        
        s = line.split()
        try:
            if s[0] == "import":
                continue
            if s[2] == "import": 
                continue;
        except:
            pass;
        open_target_filehandle.write( line ); #else write regular stuff
#end def compile2file______________________________________________________________________________


def compile2python( python_file="generation_script.py", program=None, full=1, insert="" ):    
    """compile2python does exactly the same thing as execute() but writes it to a python file.
    Like execute() this function is recursive and recursion will expect python_file to be
    a file handle instead of a string.

    Keyword Arguments:
    program:        None or list of lists or dictionaries. If it is None, then global stack is used.
    python_file:    string or file handle.
    full:           0/1. if full then all necessary generator code is also included
    """

    def is_atomic( program ):
        """checks, whether program (a list object) is containing sublists"""
        for item in program:
            if type( item ) is list:
                return 0
        return 1
    #end def is_atomic_________________________________________________________________________________

    global stack
    global data_sets
    if program is None:
        program = stack

    close_python_file = 0
    if type( python_file ) is str:
        age_file( python_file );
        python_file = open( python_file, "w" )
        python_file.write( "#!/usr/bin/python\n" )
        python_file.write( "#Data description and generators bundled together in this file for publication.\n" )
        python_file.write( "#created on " + time.ctime() + "\n" );
        python_file.write( "#by user: " + str(os.getenv( "USER" )) + "\n" )
        python_file.write( "#in path: " + os.getcwd() + "\n" )
        python_file.write( "#on machine: " + str(os.getenv( "HOSTNAME" )) + "\n" )
        python_file.write( "#generated with " + version + "\n" );
        python_file.write( "#authors " + authors + "\n" );
        python_file.write( "#get from http://paren.iupr.com\n" )

        if full:
            python_file.write( "__name__ = 'deactivate pending self tests'\n\n" )
            python_file.write( "import os, sys\nfrom numpy.random import *\nimport time\nfrom scipy.linalg import *\n" )
            python_file.write( "from time import *\nfrom pylab import *\nfrom numpy import *\nfrom scipy import *\nimport numpy\nimport scipy\n" )
            python_file.write( "from scipy.special import *\nimport csv\n" )
            compile2file( "normal_density.py", python_file )
            compile2file( "lut.py",            python_file )
            compile2file( "optimizers.py",     python_file )
            compile2file( "wgks.py",           python_file )
            compile2file( "wmcg.py",           python_file )
            compile2file( "transforms.py",     python_file )
            compile2file( "version.py",        python_file )
            compile2file( "generators.py",     python_file )

            python_file.write( "\n\n\n#=========================================================================\n" )
            python_file.write( "#THIS IS THE DATA GENERATION SECTION THAT ACTUALLY DOES SOMETHING!\n" )
            python_file.write( "#All of it is generated automatically:\n#=========================================================================\n" )
        else:
            python_file.write( "from generators import *\n" );
        python_file.write( "seed( " + str(int(rand()*1e9)) + " )\n" )
        python_file.write( "class db:\n" )
        python_file.write( "    pass\n\n\n" )

        python_file.write( "#=========================================================================\n" )
        python_file.write( "#THIS IS THE PARALLELIZATION SECTION!\n" )
        python_file.write( "#=========================================================================\n" )
        python_file.write( "VAR_TRANSACTION_ID=-1\n\n")
        python_file.write( "if len( sys.argv ) == 2:\n" )
        python_file.write( "    n = int( sys.argv[1] )\n" )
        python_file.write( "    for i in range(n):\n" ) 
        python_file.write( "        cmd = 'python ' + sys.argv[0]+ ' ' + str( n ) + ' ' + str( i ) + '& '\n" )
        python_file.write( "        print 'calling:', cmd\n" )
        python_file.write( "        os.system( cmd )\n" )
        python_file.write( "    exit(0)\n\n\n" )

        python_file.write( "try:\n" )
        python_file.write( "    CONST_STEP = max(1, int(sys.argv[1]))\n" )
        python_file.write( "    CONST_OFF  = max(0, int( sys.argv[2]))\n" )
        python_file.write( "except:\n" )
        python_file.write( "    CONST_STEP = 1\n" )
        python_file.write( "    CONST_OFF  = 0\n\n" )
        python_file.write( "#=========================================================================\n" )
        python_file.write( "#END OF THE PARALLELIZATION SECTION!\n" )
        python_file.write( "#=========================================================================\n\n\n" )
        close_python_file = 1

    if type( program ) is list:
        if program == []:
            raise Exception( "program cannot be empty!" )

        if is_atomic( program ):
            python_file.write( insert + "VAR_TRANSACTION_ID += 1\n" )
            python_file.write( insert + "if (VAR_TRANSACTION_ID-CONST_OFF)%CONST_STEP==0:\n" )
        else:
            python_file.write( insert + "if 1:\n" ) #this solution is good because indentation preserves list embedding structure and people can manually activate/deactivate portions by setting 1 to 0

        for statement in program:
            compile2python( python_file, statement, insert=insert+"    " )
        
        if close_python_file:
            python_file.write( "\n\n\n#=========================================================================\n" )
            python_file.write( "#END OF ALL FILES\n" )
            python_file.write( "#=========================================================================\n" )
            python_file.close()

    if type( program ) is dict:
        cmd = program.get( "cmd", None )
        if cmd == "wgks":
            name                    = program.get( "name", "default"+str(len(data_sets)) )
            k                       = program.get( "no_of_densities", 3 )
            target_error            = program.get( "target_error", 0.1  )
            samples_per_density     = program.get( "samples_per_density", 1000 )
            optimizer               = program.get( "optimizer", "lut" )
            samples_for_optimization= program.get( "samples_for_optimization", 1e+6 )

            data_sets[name] = { "vectors":"dummy", "labels":"dummy", "probabilities":"dummy"}
            python_file.write( insert + name + " = db()\n" )
            python_file.write( insert + name + ".v," + name + ".l," + name + ".p = white_gaussians_on_k_simplex( k=" + str(k) +", target_error=" + str(target_error) + ", samples_per_density=" + str(samples_per_density) + ", optimizer='"+optimizer+"', samples_for_optimization=" + str(samples_for_optimization) +" )\n" )


        if cmd == "k_white":
            name                    = program.get( "name", "default"+str(len(data_sets)) )
            k                       = program.get( "no_of_densities", 3 )
            d                       = program.get( "distance", 0.1  )
            samples_per_density     = program.get( "samples_per_density", 1000 )
            python_file.write( insert + name + " = db()\n" )
            python_file.write( insert + name + ".v," + name + ".l," + name + ".p = k_white_gaussians( d=" + str(d) + ",k=" + str(k) + ", samples_per_density=" + str(samples_per_density) + " )\n" )
            data_sets[name] = { "vectors":"dummy", "labels":"dummy", "probabilities":"dummy"}
    

        if cmd == "solve":
            name                    = program.get( "name", "default"+str(len(data_sets)) )
            target_error            = program.get( "target_error", 0.1  )
            total_samples           = program.get( "total_samples", 1000.0 ) #100samples per metric unit
            skeletton               = program["skeletton"] #is a must have here

            python_file.write( insert + name + " = db()\n" )
            python_file.write( insert + "tmp_skeletton = " + str_matrix( skeletton ) + "\n" )
            python_file.write( insert + name + "= SkelettonSolution( skeletton=tmp_skeletton, target_error=" + str(target_error) + ", total_samples=" + str( total_samples ) +" )\n" )
            data_sets[name] = { "skeletton":"dummy", "vectors":"dummy", "labels":"dummy", "probabilities":"dummy"}

        if cmd == "embed":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            dims                    = program["dims"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            python_file.write( insert + "if not globals().has_key('" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )
            if source_skeletton:
                python_file.write( insert + target_name + ".s = extend_dimensionality( " + source_name + ".s, " + str( dims ) + " )\n" ) 
            if source_vectors:
                python_file.write( insert + target_name + ".v = extend_dimensionality( " + source_name + ".v, " + str( dims ) + " )\n" )
            if source_labels:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]
            
        if cmd == "rand_scale":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            python_file.write( insert + "if not globals().has_key('" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )
            if source_skeletton:
                python_file.write( insert + target_name + ".s = " + source_name + ".s * " + str_matrix( program["random_scaling_vector"] ) + "\n" )
            if source_vectors:
                python_file.write( insert + target_name + ".v = " + source_name + ".v * " + str_matrix( program["random_scaling_vector"] ) + "\n" )
            if source_labels:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]
                
        if cmd == "rand_trans":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            python_file.write( insert + "if not globals().has_key('" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )
            if source_skeletton:
                python_file.write( insert + target_name + ".s = " + source_name + ".s + " + str_matrix( program["random_translation_vector"] ) + "\n" )
            if source_vectors:
                python_file.write( insert + target_name + ".v = " + source_name + ".v + " + str_matrix( program["random_translation_vector"] ) + "\n" )
            if source_labels:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]


        if cmd == "rand_rot":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            python_file.write( insert + "if not globals().has_key('" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )
            python_file.write( insert + "rot_matrix = " + str_matrix( program["random_rotation_matrix"] ) + "\n" )
            if source_skeletton:
                python_file.write( insert + target_name + ".s = dot( rot_matrix, " + source_name + ".s.T ).T\n" )
            if source_vectors:
                python_file.write( insert + target_name + ".v = dot( rot_matrix, " + source_name + ".v.T ).T\n" )
            if source_labels:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]

        if cmd == "rand_shear":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )
            python_file.write( insert + "if not globals().has_key('" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )
            python_file.write( insert + "shear_matrix = " + str_matrix( program["random_shearing_matrix"] ) + "\n" )
            if source_skeletton:
                python_file.write( insert + target_name + ".s = dot( shear_matrix, " + source_name + ".s.T ).T\n" )
            if source_vectors:
                python_file.write( insert + target_name + ".v = dot( shear_matrix, " + source_name + ".v.T ).T\n" )
            if source_labels:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]

        if cmd == "recenter":
            source_name             = program["source_name"]  #must raise exceptions if is not there
            target_name             = program["target_name"]  #must raise exceptions if is not there
            new_centroid            = program["new_centroid"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )

            python_file.write( insert + "if not globals().has_key( '" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )

            if source_skeletton is not None and source_vectors is None:
                python_file.write( insert + target_name + ".s = recenter( " + source_name + ".s, " + str_matrix( new_centroid ) + " )\n" )
            if source_skeletton is None and source_vectors is not None:
                python_file.write( insert + target_name + ".v = recenter( " + source_name + ".v, " + str_matrix( new_centroid ) + " )\n" )
            if source_skeletton is not None and source_vectors is not None:
                python_file.write( insert + "correction_vector = " + str_matrix( new_centroid - mean( source_vectors, 0 )[newaxis,:] ) + "\n" )
                python_file.write( insert + target_name + ".v = " + source_name + ".v + correction_vector\n" )
                python_file.write( insert + target_name + ".s = " + source_name + ".s + correction_vector\n" )
            if source_labels is not None:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities is not None:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]

        if cmd == "apply_cov":
            source_name             = program["source_name"] #must raise exceptions if is not there
            target_name             = program["target_name"] #must raise exceptions if is not there
            source_skeletton        = data_sets[source_name].get( "skeletton", None )
            source_vectors          = data_sets[source_name].get( "vectors", None )
            source_labels           = data_sets[source_name].get( "labels", None )
            source_probabilities    = data_sets[source_name].get( "probabilities", None )

            python_file.write( insert + "if not globals().has_key('" + target_name + "' ):\n    " + insert + target_name + " = db()\n" )
            python_file.write( insert + "new_sigma = " + str_matrix( program["new_sigma"] ) + "\n" )

            if source_skeletton and not source_vectors:
                python_file.write( insert + target_name + ".s = apply_cov_matrix( " + source_name + ".s, new_sigma )[0]\n" )
            if source_vectors and not source_skeletton:
                python_file.write( insert + target_name + ".v = apply_cov_matrix( " + source_name + ".v, new_sigma )[0]\n" )
            if source_vectors and source_skeletton:
                python_file.write( insert + target_name + ".v, " + target_name + ".s = apply_cov_matrix( " + source_name + ".v, new_sigma, [" + source_name + ".s] )\n" )
            if source_labels:
                python_file.write( insert + target_name + ".l = " + source_name + ".l\n" )
            if source_probabilities:
                python_file.write( insert + target_name + ".p = " + source_name + ".p\n" )
            data_sets[target_name] = data_sets[source_name]

        if cmd == "flush":
            if program["exporter"] is numpy_exporter:
                e = "numpy_exporter"
            if program["exporter"] is matlab_exporter:
                e = "matlab_exporter"
            if program["exporter"] is shelve_exporter:
                e = "shelve_exporter"
            if program["exporter"] is csv_exporter:
                e = "csv_exporter"
            if program["exporter"] is nirvana_exporter:
                e = "nirvana_exporter"

            for name in program["what"]:
                python_file.write( insert + "export( description(" + name + "), '" + name + "', " + e + " )\n" )
            if len( program["all"] ) > 0:
                python_file.write( insert + "del " );
                for name in program["all"]:
                    python_file.write( name+", " );
                python_file.write( "\n" )
            data_sets = {}
#end def compile2python____________________________________________________________________________


def save_data_sets( filename = "all_datasets.shelve" ):
    global data_sets
    x = shelve.open( filename, "n" )
    x["data_sets"] = data_sets
    x.close()
#end def save_data_sets____________________________________________________________________________

def restore_data_sets( filename = "all_datasets.shelve" ):
    global data_sets
    x = shelve.open( filename, "c" )
    data_sets = x["data_sets"]
    x.close()
#end def save_data_sets____________________________________________________________________________

def save_stack( filename = "generation_stack.shelve" ):
    global data_sets
    x = shelve.open( filename, "n" )
    x["stack"] = stack
    x.close()
#end def save_data_sets____________________________________________________________________________

def restore_stack( filename = "generation_stack.shelve" ):
    global data_sets
    x = shelve.open( filename, "c" )
    stack = x["stack"]
    x.close()
#end def save_data_sets____________________________________________________________________________


def numpy_exporter( name, s, v, l, p ):
    if s is not None:
        s.dump( name+".skeletton.numpy" )
    if v is not None:
        v.dump( name+".vectors.numpy" )
    if l is not None:
        l.dump( name+".labels.numpy" )
    if p is not None:
        p.dump( name+".probabilities.numpy" )
#end def numpy_exporter____________________________________________________________________________


def shelve_exporter( name, s, v, l, p ):
    x = shelve.open( name+".shelve", "n" )
    if s is not None:
        x["skeletton"] = s
    if v is not None:
        x["vectors"] = v
    if l is not None:
        x["labels"] = l
    if p is not None:
        x["probabilities"] = p
    x.close()
#end def shelve_exporter___________________________________________________________________________


def matlab_exporter( name, s, v, l, p ):
    x = {}
    if s is not None:
        x["skeletton"] = s
    if v is not None:
        x["vectors"] = v
    if l is not None:
        x["labels"] = l
    if p is not None:
        x["probabilities"] = p
    savemat( name+".mat", x )  
#end def matlab_exporter___________________________________________________________________________


def nirvana_exporter( name, s, v, l, p ):
    pass;
#end def nirvana_exporter__________________________________________________________________________


def csv_exporter( name, s, v, l, p ):
    if s is not None:
        csv_writer = csv.writer( open( name+".skeletton.csv", "w" ) )
        csv_writer.writerows( s )
    if v is not None:
        csv_writer = csv.writer( open( name+".vectors.csv", "w" ) )
        csv_writer.writerows( v )
    if l is not None:
        csv_writer = csv.writer( open( name+".labels.csv", "w" ) )
        csv_writer.writerows( l[:,newaxis] )
    if p is not None:
        csv_writer = csv.writer( open( name+".probabilities.csv", "w" ) )
        csv_writer.writerows( p )
#end def csv_eporter_______________________________________________________________________________
        

def export_data_sets( list_of_names = None, exporting_function=numpy_exporter ):
    """export_data_sets exports a series of data sets found in data_sets
    into disk files using the exporting_function ( csv_exporter, matlab_exporter, shelve_exporter, numpy_exporter).
    list_of_names can be None: in that case all data sets are taken.
    """
    global data_sets
    if list_of_names is None:
        list_of_names = data_sets.keys()
    
    if type( list_of_names ) is not list:
        list_of_names = [ list_of_names ]

    for item in list_of_names:
        db = data_sets[item]
        s = db.get( "skeletton", None )
        v = db.get( "vectors", None )
        l = db.get( "labels", None )
        p = db.get( "probabilities", None )
        exporting_function( item, s,v,l,p )
#end def export_data_sets__________________________________________________________________________


def export( db, name, exporting_function=numpy_exporter ):
    s = db.get( "skeletton", db.get( "s", None ) )
    v = db.get( "vectors", db.get( "v", None ) )
    l = db.get( "labels", db.get( "l", None ) )
    p = db.get( "probabilities", db.get( "p", None ) )
    exporting_function( name, s,v,l,p )
#end def export_data_sets__________________________________________________________________________


def description( obj ):
    keys = dir( obj )
    result = {}
    for key in keys:
        result[key] = getattr( obj, key )
    return result
#end def description_______________________________________________________________________________


def get_dims( db_name ):
    global data_sets
    try:
        db = data_sets[db_name]
        if db.has_key( "dims" ):
            return db["dims"]
        return max( db.get( "skeletton", scipy.array([[]]) ).shape[1], db.get( "vectors", scipy.array([[]]) ).shape[1] )
    except:
        print "ERROR: data_sets=", data_sets
        print "ERROR: db_name=", db_name
        print "ERROR: db=", db
        return 0    
#end def get_dims__________________________________________________________________________________



#==================================================================================================
#PUBLIC MANIPULATOR INTERFACES
#read demo.py for examples
#==================================================================================================
def CLEAR():
    global stack
    stack = []
#end def___________________________________________________________________________________________

def WGKS( name=None, no_of_densities=3, target_error=0.1, samples_per_density=1000, optimizer="lut", samples_for_optimization=1e5 ):
    global stack
    global data_sets
    stack += [{ "cmd":"wgks", "name":name, "no_of_densities":no_of_densities, "target_error":target_error, "samples_per_density":samples_per_density, "optimizer":optimizer, "samples_for_optimization":samples_for_optimization } ]
    data_sets[name] = {"vectors":"dummy", "labels":"dummy", "probabilities":"dummy", "dims":no_of_densities-1}
#end def___________________________________________________________________________________________


def KWHITES( name=None, no_of_densities=3, distance=1.0, samples_per_density=1000 ):
    global stack
    global data_sets
    stack += [{ "cmd":"k_white", "name":name, "no_of_densities":no_of_densities, "distance":distance, "samples_per_density":samples_per_density } ]
    data_sets[name] = {"vectors":"dummy", "labels":"dummy", "probabilities":"dummy", "dims":no_of_densities-1}
#end def___________________________________________________________________________________________

    
def GCG( name=None, target_error=0.1, no_of_chains=2, chain_lengths=40, no_of_chain_seeds=100, seed_sigma=scipy.eye(2), target_angle=180.0, speed=1.0, total_samples=10000 ):
    global stack
    global data_sets
    skeletton = gaussian_skeletton( no_of_chain_seeds, seed_sigma, no_of_chains, chain_lengths, target_angle, speed )
    stack += [ {"cmd":"solve", "name":name, "target_error":target_error, "total_samples":total_samples, "skeletton":skeletton} ]
    data_sets[name] = {"vectors":"dummy", "labels":"dummy", "probabilities":"dummy", "skeletton":"dummy", "dims":seed_sigma.shape[0]}
#end def___________________________________________________________________________________________


def SCG( name=None, target_error=0.1, radius=2.0, no_of_chains=2, chain_lengths=50, no_of_chain_seeds=100, seed_sigma=scipy.eye(3), target_angle=180.0, speed=1.0, total_samples=10000 ):
    global stack
    global data_sets
    skeletton = gaussian_skeletton( no_of_chain_seeds, seed_sigma, no_of_chains, chain_lengths, target_angle, speed )
    skeletton *= radius/sqrt( sum( skeletton**2, 1 ) )[:,newaxis,:] #normalize
    stack += [ {"cmd":"solve", "name":name, "target_error":target_error, "total_samples":total_samples, "skeletton":skeletton} ]
    data_sets[name] = {"vectors":"dummy", "labels":"dummy", "probabilities":"dummy", "skeletton":"dummy", "dims":seed_sigma.shape[0]}
#end def___________________________________________________________________________________________

            
def WMCG( name=None, target_error=0.1, no_of_chains=2, chain_lengths=15, seed_sigma=scipy.eye(2)*2, target_angle=180.0, speed=1.0, total_samples=10000.0, 
          test_samples=1000, fix_speed=0, fix_angle=0, resample=1 ):
    global stack
    global data_sets
    g = gaussian( no_of_chains, seed_sigma )
    skeletton = grow_wmcg_skeletton( g, chain_lengths, target_angle, speed, test_samples, fix_speed, fix_angle, resample )
    stack += [{ "cmd":"solve", "name":name, "target_error":target_error, "no_of_chains":no_of_chains, 
                "chain_lengths":chain_lengths, "seed_sigma":seed_sigma, "target_angle":target_angle, 
                "speed":speed, "total_samples":total_samples, "test_samples":test_samples, 
                "fix_speed":fix_speed, "fix_angle":fix_angle, "resample":resample, "skeletton":skeletton } ]
    data_sets[name] = {"vectors":"dummy", "labels":"dummy", "probabilities":"dummy", "skeletton":"dummy", "dims":seed_sigma.shape[0]}
#end def___________________________________________________________________________________________


def EMBED( source_name, target_name, dims ):
    global stack
    global data_sets
    stack += [ { "cmd":"embed", "source_name":source_name, "target_name":target_name, "dims":dims } ]
    db = data_sets.get(target_name, data_sets[source_name].copy())
    db["dims"]=dims
    data_sets[target_name] = db
#end def___________________________________________________________________________________________


def RSCALE( source_name, target_name, sigma=1.0 ):
    global stack
    dims = get_dims( source_name )
    scales = random_scaling_vector( dims, sigma )
    stack += [ { "cmd":"rand_scale", "source_name":source_name, "target_name":target_name, "random_scaling_vector":scales } ]
    db = data_sets.get(target_name,  data_sets[source_name].copy() )
    data_sets[target_name] = db
#end def___________________________________________________________________________________________

    
def RMOVE( source_name, target_name, scale=1.0, move_type="gauss" ):
    global stack
    dims = get_dims( source_name )
    if dims <= 0:
        raise Exception( "dims for '" + source_name + "' is " + str(dims) + " and that's a problem. Source does exist?" )
    delta = random_translation_vector( dims, move_type, scale )
    stack += [ { "cmd":"rand_trans", "source_name":source_name, "target_name":target_name, "random_translation_vector":delta } ]
    db = data_sets.get(target_name, data_sets[source_name].copy() )
    data_sets[target_name] = db
#end def___________________________________________________________________________________________

    
def RROT( source_name, target_name ):
    global stack
    dims = get_dims( source_name )
    rot_mat = random_rotation_matrix( dims )
    stack += [ { "cmd":"rand_rot", "source_name":source_name, "target_name":target_name, "random_rotation_matrix":rot_mat } ]
    db = data_sets.get(target_name,  data_sets[source_name].copy() )
    data_sets[target_name] = db
#end def___________________________________________________________________________________________


def RSHEAR( source_name, target_name, sigma_list=[1.0] ):
    global stack
    dims = get_dims( source_name )
    rot_shear = random_shearing_matrix( dims, sigma_list )
    stack += [ { "cmd":"rand_shear", "source_name":source_name, "target_name":target_name, "random_shearing_matrix":rot_shear } ]
    db = data_sets.get(target_name, data_sets[source_name].copy() )
    data_sets[target_name] = db
#end def___________________________________________________________________________________________


def NORMCOV( source_name, target_name, cov_matrix ):
    global stack
    stack += [ { "cmd":"apply_cov", "source_name":source_name, "target_name":target_name, "new_sigma":cov_matrix } ]
    db = data_sets.get(target_name, data_sets[source_name].copy() )
    data_sets[target_name] = db
#end def___________________________________________________________________________________________


def CENTER( source_name, target_name, new_centroid ):
    global stack
    stack += [ { "cmd":"recenter", "source_name":source_name, "target_name":target_name, "new_centroid":atleast_2d( new_centroid ) } ]
    db = data_sets.get(target_name, data_sets[source_name].copy() )
    data_sets[target_name] = db
#end def___________________________________________________________________________________________


def FLUSH( what=None, exporter_function=numpy_exporter ):
    global stack
    global data_sets
    if what is None:
        what = data_sets.keys()
    all_sets = data_sets.keys()
    if type(what) is not list:
        what = [ what ]
    stack += [ { "cmd":"flush", "what":what, "exporter":exporter_function , "all":all_sets} ]
    data_sets = {}
#end def___________________________________________________________________________________________


def TRANSACTION():
    global stack
    transaction = []
    try:
        FLUSH( exporter_function=nirvana_exporter )
        while type(stack[-1]) is dict:
            transaction += [stack.pop(-1)]
    except:
        pass
    finally:
        transaction.reverse()
        if transaction != []:
            stack += [transaction]

#end def___________________________________________________________________________________________
    
    
def random_color():
    symbols = "0248F"
    color = "#"
    for i in arange( 6 ):
        color += symbols[ int32( 4.4 * rand() ) ]
    return color
    


glob_fig = None
def draw1( s, v, l, y_lim=[-10,10], x_lim=[-10,10], wait=3 ):
    """drawt is a DrawTranslator() function replacement"""
    global glob_fig
    ion()
    if glob_fig is None:
        glob_fig = figure(figsize=(15,15))
    glob_fig.clear()
    glob_fig.show()
    d = len(s)
    hold( 'on' )
    color_list = []
    for k in range( d ):
        color_list += [ random_color() ]
        selected = get_indices( int32( l == k ) )
        plot( v[selected,0], v[selected,1], '.', color=color_list[k] )        
    for k in range( d ):
        plot( s[k,0,:], s[k,1,:], color=color_list[k] )
        plot( s[k,0,:], s[k,1,:],'o', color=color_list[k] )
    ylim(y_lim);xlim(x_lim)
    hold( 'off' )
    sleep(wait)


def draw2( v, l, y_lim=[-10,10], x_lim=[-10,10], wait=3 ):
    """drawt is a DrawTranslator() function replacement"""
    global glob_fig
    ion()
    if glob_fig is None:
        glob_fig = figure(figsize=(15,15))
    glob_fig.clear()
    glob_fig.show()
    d = len( unique( l ) )
    hold( 'on' )
    for k in range( d ):
        selected = get_indices( int32( l == k ) )
        plot( v[selected,0], v[selected,1], '.' )        
    ylim(y_lim);xlim(x_lim)
    hold( 'off' )
    sleep(wait)


def VISUALIZE( names=None, y_lim=[-10,10], x_lim=[-10,10], wait=3  ):
    global data_sets

    if names is None:
        names = data_sets.keys()

    if type( names ) == str:
        names = [names]

    for name in names:
        d = data_sets[name]
        if d.has_key( "skeletton" ):
            print "d=", d
            print "s.shape=", d["skeletton"].shape
            draw1( d["skeletton"], d["vectors"], d["labels"], y_lim, x_lim, wait )
        else:
            draw2( d["vectors"], d["labels"], y_lim, x_lim, wait )
        savefig( name+".pdf" )

def EXEC():
    execute()

#==================================================================================================
#END OF FILE
#==================================================================================================




#=========================================================================
#THIS IS THE DATA GENERATION SECTION THAT ACTUALLY DOES SOMETHING!
#All of it is generated automatically:
#=========================================================================
seed( 987991743 )
class db:
    pass


#=========================================================================
#THIS IS THE PARALLELIZATION SECTION!
#=========================================================================
VAR_TRANSACTION_ID=-1

if len( sys.argv ) == 2:
    n = int( sys.argv[1] )
    for i in range(n):
        cmd = 'python ' + sys.argv[0]+ ' ' + str( n ) + ' ' + str( i ) + '& '
        print 'calling:', cmd
        os.system( cmd )
    exit(0)


try:
    CONST_STEP = max(1, int(sys.argv[1]))
    CONST_OFF  = max(0, int( sys.argv[2]))
except:
    CONST_STEP = 1
    CONST_OFF  = 0

#=========================================================================
#END OF THE PARALLELIZATION SECTION!
#=========================================================================


VAR_TRANSACTION_ID += 1
if (VAR_TRANSACTION_ID-CONST_OFF)%CONST_STEP==0:
    a = db()
    tmp_skeletton = array( [array( [array( [-2.28025791914,-1.05166384351,-1.40176161228,-0.175518853061,-1.25282188156,-1.32143484346,-3.65079490944,-3.96604664137,-5.02307633557,-5.2268780507,]),array( [2.72114213922,3.37876716693,2.83076830421,2.71169412304,1.82718447301,1.67524106817,1.60893298646,1.50841042169,2.6400793541,3.60266155223,]),]),array( [array( [-3.01703173293,-2.22450705201,-2.63604996801,-4.88804431243,-7.26170410588,-5.40694374252,-6.19317241739,-6.78528984191,-8.03600921909,-9.48510810458,]),array( [3.9392640664,7.75492614172,8.94076026962,9.58143546869,8.64081260893,8.4912463262,8.12133230838,9.18867923107,10.1213237996,10.0367038626,]),]),])
    a= SkelettonSolution( skeletton=tmp_skeletton, target_error=0.1, total_samples=10000.0 )



#=========================================================================
#END OF ALL FILES
#=========================================================================
